// copyright 2003 Neil Barnes 
//
// nailed_barnacle@hotmail.com
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the license, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

#define _CRT_SECURE_NO_DEPRECATE

#include "stdafx.h"


#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <windows.h>
#include <stdio.h>
#include <io.h>
#include <mmsystem.h>
#include <setupapi.h>
#include <objbase.h>
#include <initguid.h>
#include <devguid.h>
#include <regstr.h>
#include <mbstring.h>

// The following define is from ntddser.h in the DDK. It is also
// needed for serial port enumeration.
#ifndef GUID_CLASS_COMPORT
DEFINE_GUID(GUID_CLASS_COMPORT, 0x86e0d1e0L, 0x8089, 0x11d0, 0x9c, 0xe4, \
			0x08, 0x00, 0x3e, 0x30, 0x1f, 0x73);
#endif

#include "emudisplay.h"

static _enginetype et = NOTHING;
static BOOL Logging = FALSE;

// Globals for serial stuff

static HANDLE  rs232;
static DCB			dcb;
static DWORD		txcount,rxcount;
static COMMTIMEOUTS	cto;
static char comport[10];
static int baudrate;

// the tx and rx frame buffers

unsigned char txframe[15];
unsigned char rxframe[15];
unsigned char rxbuffer[64];

////////////////////////////////////////////////////////////////////////////////////////////////////////////
int PASCAL WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszCmdLine, int nCmdShow)
{   

MSG         msg ;      // a message
WNDCLASS    wndclass ; // the window class 


	if (!hPrevInstance)    // load data into window class struct. 
    {
      wndclass.style         = CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS;
      wndclass.lpfnWndProc   = (WNDPROC)WndProc ;
      wndclass.cbClsExtra    = 0 ;
      wndclass.cbWndExtra    = 0 ;
      wndclass.hInstance     = hInstance ;
      wndclass.hIcon         = LoadIcon (hInstance, "IDI_ICON1") ;
			wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW) ;
      wndclass.hbrBackground = (HBRUSH)GetStockObject (BLACK_BRUSH) ;
	  	wndclass.lpszMenuName  = MAKEINTRESOURCE(IDR_MENU1) ;
	  	wndclass.lpszClassName = szProgName ;
          
                                    // register the window class 
      if (!RegisterClass (&wndclass))
      	return FALSE ;
    }
    
	ghInstance = hInstance;

	hWnd = CreateWindowEx (      	// create the program's window here
        0l,
				szProgName,             // class name 
        szProgName,             // window name 
				WS_OVERLAPPEDWINDOW,
				//| WS_VSCROLL,						// window style
        CW_USEDEFAULT,					// x position on screen 
				CW_USEDEFAULT,					// y position on screen
				630,
				585,
        NULL,                   // parent window handle (null = none) 
        NULL,                   // menu handle (null = class menu) 
        hInstance,              // instance handle 
        NULL) ;                 // lpstr (null = not used) 

    ShowWindow (hWnd, nCmdShow) ;   
		UpdateWindow (hWnd) ;       // send first WM_PAINT message

    while (GetMessage (&msg, NULL, 0, 0))   // the message loop 
    {
    	TranslateMessage (&msg) ;
			DispatchMessage (&msg) ;
    }
    return msg.wParam ;
}


/////////////////////////////////////////////////////////////////////////////////////////////////////////////
Gauge::Gauge (char * _title, char * _units, int _height, int _x, int _y, int _low, int _high, 
							int _majortick, int _minortick,	int _hieek, int _hiwarn, int _lowarn, int _loeek,
							int _places)
{
	// constructor for gauge; it just sets all the parameters
	height = _height;
	x = _x;
	y = _y;
	low = _low;
	high = _high;
	majortick = _majortick;
	minortick = _minortick;
	hieek = _hieek;
	hiwarn = _hiwarn;
	lowarn = _lowarn;
	loeek = _loeek;
	value = (float)low;
	places = _places;
	strcpy(title,_title);
	strcpy(units,_units);
}

void Gauge::Show (HDC hDC, float _value)
{
	// draw the gauge - called in wm_paint

HBRUSH	holdbrush;

	holdbrush = (HBRUSH)SelectObject(hDC,hbMurple);
	RoundRect (hDC,x+1,y+1,x+99,y+height-1,30,30);

	// the main bar
	Rectangle (hDC, x+20,y+25,x+25,y+height-24);

	SelectObject(hDC,holdbrush);

int bigticks;
int littleticks;
char tickmark[10];

POINT arrow[3];

char amount[20];

	value = max(_value,low);
	value = min(_value,high);

	bigticks = (high-low)/majortick;
	littleticks = (high-low)/minortick;

	// ticks
	for (int q = 0; q <= bigticks; q++)
	{
		MoveToEx(hDC,x+25,(y+height-25)-(q*(height-50)/bigticks),NULL);
		LineTo(hDC,x+35,(y+height-25)-(q*(height-50)/bigticks));
		sprintf(tickmark,"%d",((high-low)*q/bigticks)+low);
		SetBkColor(hDC,MURPLE);
		SetTextAlign(hDC,TA_BASELINE);
		TextOut(hDC,x+38,(y+height-20)-(q*(height-50)/bigticks),tickmark,strlen(tickmark));
 	}

	for (int q = 0; q <= (high-low)/minortick; q++)
	{
		MoveToEx(hDC,x+25,(y+height-25)-(q*(height-50)/littleticks),NULL);
		LineTo(hDC,x+30,(y+height-25)-(q*(height-50)/littleticks));
 	}

	// we need to undraw the old pointer and draw a new one
	
	// we load the arrow array with the vertices
	arrow[1].x = x+19;
	arrow[1].y = (y+height-25)-(int)((value-low)*(height-50)/(high-low));
	arrow[2].x = x+9;
	arrow[2].y = arrow[1].y+10;
	arrow[0].x = x+9;
	arrow[0].y = arrow[1].y-10;

	// select the colour of the arrow
	if (value > hieek)
		holdbrush = (HBRUSH)SelectObject(hDC,hbRed);
	else
		if (value > hiwarn)
			holdbrush = (HBRUSH)SelectObject(hDC,hbAmber);
		else
			if (value > lowarn)
				holdbrush = (HBRUSH)SelectObject(hDC,hbGreen);
			else
				if (value > loeek)
					holdbrush = (HBRUSH)SelectObject(hDC,hbAmber);
				else
					holdbrush = (HBRUSH)SelectObject(hDC,hbRed);	
	
	Polygon(hDC,arrow,3);

	SelectObject(hDC,holdbrush);

	// more stuff here; undraw the old arrow, draw the new one with colours
	// depending on the value

	// the title of the gauge
	SetTextAlign(hDC,TA_BASELINE | TA_CENTER);
	TextOut(hDC,x+50,y+15,title,strlen(title));

	// and the actual value
	sprintf(amount,"%.*f %s",places,(double)value,units);
	TextOut(hDC,x+50,y+height-5,amount,strlen(amount));
	
}

void Gauge::Rescale(int _low,						// minimum display value
							int _high,					// maximum display value
							int _majortick,			// interval between labeled index marks
							int _minortick,			// interval between unlabeled index marks
							int _hieek,					// high danger level
							int _hiwarn,				// high warning level
							int _lowarn,				// low warning level (i.e. warn if below this value
							int _loeek)					// low danger level
{
	// change the range of the scale without moving it - does not redisplay
	low = _low;
	high = _high;
	majortick = _majortick;
	minortick = _minortick;
	hieek = _hieek;
	hiwarn = _hiwarn;
	lowarn = _lowarn;
	loeek = _loeek;
}

void Gauge::Update (HDC hDC, float _value)
{
	// update the display by redrawing only the pointer and the value

HBRUSH	holdbrush;

	holdbrush = (HBRUSH)SelectObject(hDC,hbMurple);
	SelectObject(hDC,GetStockObject(NULL_PEN));

		// erase the entire pointer space
	RoundRect (hDC,x+2,y+10,x+21,y+height-10, 10,10);
		// and the value display area
	RoundRect (hDC,x+10,y+height-20,x+90,y+height-1,10,10);

	SelectObject(hDC,holdbrush);
	SelectObject(hDC,GetStockObject(BLACK_PEN));


POINT arrow[3];

char amount[20];

	value = max(_value,low);
	value = min(_value,high);

	// we need to undraw the old pointer and draw a new one
	
	// we load the arrow array with the vertices
	arrow[1].x = x+19;
	arrow[1].y = (y+height-25)-(int)((value-low)*(height-50)/(high-low));
	arrow[2].x = x+9;
	arrow[2].y = arrow[1].y+10;
	arrow[0].x = x+9;
	arrow[0].y = arrow[1].y-10;

	// select the colour of the arrow
	if (value > hieek)
		holdbrush = (HBRUSH)SelectObject(hDC,hbRed);
	else
		if (value > hiwarn)
			holdbrush = (HBRUSH)SelectObject(hDC,hbAmber);
		else
			if (value > lowarn)
				holdbrush = (HBRUSH)SelectObject(hDC,hbGreen);
			else
				if (value > loeek)
					holdbrush = (HBRUSH)SelectObject(hDC,hbAmber);
				else
					holdbrush = (HBRUSH)SelectObject(hDC,hbRed);	
	
	Polygon(hDC,arrow,3);

	SelectObject(hDC,holdbrush);
	// the title of the gauge
	SetTextAlign(hDC,TA_BASELINE | TA_CENTER);
	SetBkMode(hDC,TRANSPARENT);

	// and the actual value
	sprintf(amount,"%.*f %s",places,(double)value,units);
	TextOut(hDC,x+50,y+height-5,amount,strlen(amount));
	
}

int	Gauge::Percentage (void)
{
	// returns current value being displayed as a percentage of the range visible
	return (int)((value-low)*100/(high-low));
}

// let's have some gauges to display. They're global, will get deleted on program close

Gauge rpm ("Revs","rpm",400,10,30,0,8000,1000,200,6500,6000,1500,1000,0);
Gauge airtemp ("Air","C",200,110,30,-55,125,30,5,105,95,-60,-60,0);
Gauge pressure ("Pressure","mb",200,210,30,0,1250,250,50,1200,1200,0,0,0);
Gauge throttle ("Throttle","deg",200,310,30,0,90,30,10,90,90,0,0,1);
Gauge battery ("Volts","V",200,410,30,0,15,3,1,15,14,13,12,2);
Gauge injperiod ("Injector","mS",200,110,230,0,75,15,3,75,75,0,0,3);
Gauge injtime ("Inj. timing","deg",200,210,230,0,720,180,45,720,720,0,0,0);
Gauge advance ("Advance","deg",200,310,230,0,75,15,3,75,75,0,0,0);
Gauge vae ("VAE","%",200,410,230,0,100,20,5,100,100,0,0,0);
Gauge watertemp ("Water","C",400,510,30,-55,125,15,5,105,95,-60,-60,0);

// a structure to keep the results from the engine management	query
static _engine engine;

// and one for the massaged data
static _massage massage;

static FILE * fo = NULL;


/////////////////////////////////////////////////////////////////////////////////////////////////////////////

LRESULT CALLBACK WndProc (HWND hWnd, UINT iMessage, WPARAM wParam, LPARAM lParam)
{

// variables for comms list box
// variables for comms list box
static HWND hComlist;
char kpath[] = "HARDWARE\\DEVICEMAP\\SERIALCOMM";
unsigned char lpData[1024];				// buffer for value data 

// variables for comms detection
HDEVINFO hDevInfo;
SP_DEVINFO_DATA DeviceInfoData;
DWORD i;


GUID *guidDev = (GUID*) &GUID_CLASS_COMPORT;

int q;

// main program loop
	switch (iMessage)
  {

		//----------------------------------------------------------------------
		case WM_CREATE:

			hbRed = CreateSolidBrush(RED);
			hbGreen = CreateSolidBrush(GREEN);
			hbAmber = CreateSolidBrush(AMBER);
			hbMurple = CreateSolidBrush(MURPLE);

			massage.uniram1 = 0;
			massage.uniram2 = 0;
			massage.uniram3 = 0;

			// wake up the comms
			// default is to assume we're attached to a 16v na, cos that's what I drive :)

			baudrate = 7680;

			// build a drop-down list for the comms port selection
			hComlist = CreateWindowEx(
									0l,
									"COMBOBOX",							// class name 
									NULL,										// window name 
									WS_CHILD
									| WS_VISIBLE
									| CBS_HASSTRINGS
									//| CBS_SORT
									| CBS_DROPDOWNLIST,						// window style
									20,											// x position on screen 
									6,											// y position on screen
									190,
									200,
									hWnd,                   // parent window handle (null = none) 
									(HMENU) IDW_SETCOMMS,		// menu handle (null = class menu) 
									ghInstance,             // instance handle 
									NULL) ;                 // lpstr (null = not used) 

			ShowWindow(hComlist, SW_SHOW);			// Display the window 
			SendMessage(hComlist, CB_INSERTSTRING, 0, (LPARAM)"Select serial port");


			// Create a HDEVINFO with all present comms devices.
			hDevInfo = SetupDiGetClassDevs(guidDev,
																		0, // Enumerator
																		0,
																		DIGCF_PRESENT | DIGCF_DEVICEINTERFACE );

			if (hDevInfo == INVALID_HANDLE_VALUE)
			{
				// Insert error handling here.
				MessageBox(NULL,"Sorry, there's a problem identifying serial ports. I have to close.","Error",MB_ICONSTOP);
				return 1;
			}

			// Enumerate through all comms devices in Set.

			DeviceInfoData.cbSize = sizeof(SP_DEVINFO_DATA);
			for (i=0;SetupDiEnumDeviceInfo(hDevInfo,i,&DeviceInfoData);i++)
			{
			DWORD DataT;
			LPTSTR buffer = NULL;
			DWORD buffersize = 0;

				// Call function with null to begin with,
				// then use the returned buffer size
				// to Alloc the buffer. Keep calling until
				// success or an unknown failure.

				while (!SetupDiGetDeviceRegistryProperty(
							hDevInfo,
							&DeviceInfoData,
							//SPDRP_DEVICEDESC,
							SPDRP_FRIENDLYNAME,
							&DataT,
							(PBYTE)buffer,
							buffersize,
							&buffersize))
				{
					if (GetLastError() ==
						ERROR_INSUFFICIENT_BUFFER)
					{
						// Change the buffer size.
						if (buffer) LocalFree(buffer);
						buffer = (LPTSTR)LocalAlloc(LPTR,buffersize);
					}
					else
					{
						// Insert error handling here.
						break;
					}
				}
				
				SendMessage(hComlist, CB_ADDSTRING, 0, (LPARAM)buffer);

				if (buffer) LocalFree(buffer);
			}

			if ( GetLastError()!=NO_ERROR &&
			GetLastError()!=ERROR_NO_MORE_ITEMS )
			{
			// Insert error handling here.
			return 1;
			}

			//  Cleanup
			SetupDiDestroyDeviceInfoList(hDevInfo);
	
			// if there are no com ports found, we need to quit with a friendly message
			if (i == 0)			// i counts the number of ports found
			{
				MessageBox(NULL,"I'm sorry - I can't find any serial or USB ports. Please attach one and restart the program.",
									"Fiat ECU monitor - Port Error",MB_ICONSTOP);
				SendMessage(hWnd,WM_DESTROY,0,0);
			}
			else
			{
				// set the default item; first in list
				SendMessage(hComlist, CB_SETCURSEL, (WPARAM)0,0);

				// and then we fake a message from the listbox to ourselves
				// we claim to have changed the contents and that causes an init of the serial port
				//SendMessage(hWnd,WM_COMMAND, MAKEWPARAM(IDW_SETCOMMS, CBN_SELCHANGE),	(LPARAM)hComlist);
			}

			// start a timer running
			SetTimer(hWnd,TICKTOCK,500,NULL);

			break;

		//----------------------------------------------------------------------
		case WM_DESTROY:

			KillTimer(hWnd,TICKTOCK);
			_fcloseall();
			PostQuitMessage (0) ;
      break;

		//----------------------------------------------------------------------
		case WM_TIMER:
			// we get here regularly
			// ask the engine what's going on, man...

			// different for turbo and na, 16 and 20v <sigh>

			if (et == NOTHING)
				break;

			if ((et == _16VNA) || (et == _16VT))
			{

				// engine period msb,lsb
				engine.revs.little[1] = Get16vEngineStatus(1,engine.revs.little[1]);
				engine.revs.little[0] = Get16vEngineStatus(2,engine.revs.little[0]);

				// injector period msb,lsb
				engine.injperiod.little[1] = Get16vEngineStatus(3,engine.injperiod.little[1]);
				engine.injperiod.little[0] = Get16vEngineStatus(4,engine.injperiod.little[0]);

				// advance
				engine.advance = Get16vEngineStatus(5,engine.advance);

				// manifold pressure
				engine.vacuum = Get16vEngineStatus(6,engine.vacuum);

				// air and water temp
				engine.airtemp = Get16vEngineStatus(7,engine.airtemp);
				engine.watertemp = Get16vEngineStatus(8,engine.watertemp);

				// throttle valve angle
				engine.throttle = Get16vEngineStatus(9,engine.throttle);

				// battery voltage
				engine.battery = Get16vEngineStatus(10,engine.battery);

				// injection timing angle
				engine.injtiming = Get16vEngineStatus(12,engine.injtiming);

				// VAE duty cycle (idle control valve)
				engine.vae = Get16vEngineStatus(13,engine.vae);

				// now we get the temporary errors from ram

				engine.uniram1 = Get16vEngineStatus(15,engine.uniram1);
				engine.uniram2 = Get16vEngineStatus(16,engine.uniram2);
				engine.uniram3 = Get16vEngineStatus(17,engine.uniram3);

				// now we've got everything handy, we have to massage this to something 
				// a human can understand

				// 30,000,000/engine period = revs per minute
				if (engine.revs.big != 0)
					massage.revs = (float)30000000/engine.revs.big;
				else
					massage.revs = (float)0;

				// 4* injector period = period in us
				massage.injperiod = (float)(engine.injperiod.big*4)/1000;  // we like ms

				// advance/4 = degrees
				massage.advance = (float)engine.advance/4;

				if (et == _16VNA)
				{
					// manifold pressure for NA is vacuum*2.8758 + 91 mmHg
					// but millibar is more useful, and as one mb = 0.75mmHg
					// we can multiply the result by 4/3
					massage.vacuum = (float)((((float)engine.vacuum*2.8758)+91)*4/3);
				}
				else 
				{
					// it's a turbo, the rules are different
					// now it's data*6.4161+45.63, mult by 4/3 to get millibar
					massage.vacuum = (float)((((float)engine.vacuum*6.4161)+45.63)*4/3);
				}

				// air and water temperature are read directly from the look-up table
				massage.airtemp = (float)temperature[engine.airtemp];
				massage.watertemp = (float)temperature[engine.watertemp];

				// throttle valve angle is different depending on value
				// if angle is less than 30 degrees, angle is (value*0.1848)-1.41 degrees
				// if greater than 30 degrees, angle is (value*0.7058)-90 degrees
				// the turnover point is when the value is 171
				// this gives a much greater precision on small throttle openings

				if (engine.throttle <171)
					massage.throttle = (float)(((float)engine.throttle*0.1848)-1.41);
				else
					massage.throttle = (float)(((float)engine.throttle*0.7058)-90);

				// battery voltage
				// value * 0.0628 volts
				massage.battery = (float)((float)engine.battery*0.0628);

				// injector timing angle
				// multiply byte by 90/4, subtract from 720
				// I'm not certain about the range here...

				massage.injtiming = (float)(720-((float)engine.injtiming*90/4));

				// and the last of the data displays - vae position
				// just multiply by 100 and divide by 255 for percentage

				massage.vae = (float)((float)engine.vae*100/255);
			}

			// then update display

			/*
			sprintf(title,"%02x %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x",
							engine.revs.little[1],
							engine.revs.little[0],
							engine.injperiod.little[1],
							engine.injperiod.little[0],
							engine.advance,
							engine.vacuum,
							engine.airtemp,
							engine.watertemp,
							engine.throttle,
							engine.battery,
							engine.injtiming,
							engine.vae);

			SetWindowText(hWnd,title);
			*/

			hDC = GetDC(hWnd);

			rpm.Update(hDC,massage.revs);
			airtemp.Update(hDC,massage.airtemp);
			watertemp.Update(hDC,massage.watertemp);
			injperiod.Update(hDC,massage.injperiod);
			injtime.Update(hDC,massage.injtiming);
			advance.Update(hDC,massage.advance);
			pressure.Update(hDC,massage.vacuum);
			throttle.Update(hDC,massage.throttle);
			battery.Update(hDC,massage.battery);
			vae.Update(hDC,massage.vae);

			// now we check to see whether there's been any change in the error status bytes
			if ((engine.uniram1 != massage.uniram1) || (engine.uniram2 != massage.uniram2) || (engine.uniram3 != massage.uniram3))
			{
				
				//MessageBox(hWnd,"Different","",MB_OK);
				// if there has, store the new bytes
				massage.uniram1 = engine.uniram1;
				massage.uniram2 = engine.uniram2;									
				massage.uniram3 = engine.uniram3;

				// and display the data
				InvalidateRect(hWnd,NULL,FALSE);
				UpdateWindow(hWnd);
			}

			ReleaseDC(hWnd,hDC);

			// and then last thing - if a file was created, we save the data
			// we save the data both as raw data (after conversion to real numbers) 
			// and as percentages of the range visible on the meters
			if (Logging)
			{
				fprintf(fo,"%f, %f, %f, %f, %f, %f, %f, %f, %f, %f, %d, %d, %d, , %d, %d, %d, %d, %d, %d, %d, %d, %d, %d\n", 
								massage.revs, 
								massage.watertemp,
								massage.airtemp,
								massage.throttle,
								massage.injperiod, 
								massage.injtiming, 
								massage.advance, 
								massage.battery, 
								massage.vacuum, 
								massage.vae,
								engine.uniram1, 
								engine.uniram2,
								engine.uniram3,
								rpm.Percentage(),
								watertemp.Percentage(),
								airtemp.Percentage(),
								throttle.Percentage(),
								injperiod.Percentage(),
								injtime.Percentage(),
								advance.Percentage(),
								battery.Percentage(),
								pressure.Percentage(),
								vae.Percentage());
			}
			break;


		//----------------------------------------------------------------------
		case WM_PAINT:

			BeginPaint(hWnd,&ps);

			/// output the active data
			rpm.Show(ps.hdc,massage.revs);
			airtemp.Show(ps.hdc,massage.airtemp);
			watertemp.Show(ps.hdc,massage.watertemp);
			injperiod.Show(ps.hdc,massage.injperiod);
			injtime.Show(ps.hdc,massage.injtiming);
			advance.Show(ps.hdc,massage.advance);
			pressure.Show(ps.hdc,massage.vacuum);
			throttle.Show(ps.hdc,massage.throttle);
			battery.Show(ps.hdc,massage.battery);
			vae.Show(ps.hdc,massage.vae);

			// and use the error bits to light 'leds'
HBRUSH	holdbrush;

			holdbrush = (HBRUSH)SelectObject(ps.hdc,hbMurple);
			RoundRect (ps.hdc,11,431,609,529,20,20);
			SelectObject(ps.hdc,holdbrush);

			SetTextAlign(ps.hdc,TA_BASELINE | TA_LEFT);
			SetBkMode(ps.hdc,TRANSPARENT);
			
			if (engine.uniram1 & 1)
			{
				// idle control valve blocked either open or closed
				holdbrush = (HBRUSH)SelectObject(ps.hdc,hbRed);
				RoundRect (ps.hdc,21,436,201,456,20,20);
				SelectObject(ps.hdc,holdbrush);
			}
			TextOut(ps.hdc,31,451,"VAE open or closed",18);
			
			if (engine.uniram1 & 2)
			{
				// mixture control out of range
				// if uniram3.1 = 0, maximum rich, else maximum lean
				holdbrush = (HBRUSH)SelectObject(ps.hdc,hbRed);
				RoundRect (ps.hdc,21,456,201,476,20,20);
				SelectObject(ps.hdc,holdbrush);
				if (engine.uniram3 & 1)
					TextOut(ps.hdc,31,471,"Maximum lean-down",17);
				else
					TextOut(ps.hdc,31,471,"Maximum enrichment",18);
			}
			else
				TextOut(ps.hdc,31,471,"Mixture range limit",19);

			if (engine.uniram1 & 4)
			{
				// air temperature sensor problems
				// if uniram3.2 = 0, sensor open circuit, else short circuit
				holdbrush = (HBRUSH)SelectObject(ps.hdc,hbRed);
				RoundRect (ps.hdc,21,476,201,496,20,20);
				SelectObject(ps.hdc,holdbrush);
				if (engine.uniram3 & 2)
					TextOut(ps.hdc,31,491,"Air temp sensor S/C",19);
				else
					TextOut(ps.hdc,31,491,"Air temp sensor O/C",19);
			}
			else
				TextOut(ps.hdc,31,491,"Air temperature sensor",22);
			
			if (engine.uniram1 & 8)
			{
				// knock sensor activated
				holdbrush = (HBRUSH)SelectObject(ps.hdc,hbRed);
				RoundRect (ps.hdc,21,496,201,516,20,20);
				SelectObject(ps.hdc,holdbrush);
			}
			TextOut(ps.hdc,31,511,"Knock",5);

			if (engine.uniram1 & 16)
			{
				// water sensor problems
				// if uniram3.3 = 1, short circuit, else open circuit
				holdbrush = (HBRUSH)SelectObject(ps.hdc,hbRed);
				RoundRect (ps.hdc,221,436,401,456,20,20);
				SelectObject(ps.hdc,holdbrush);
				if (engine.uniram3 & 4)
					TextOut(ps.hdc,231,451,"Water temp sensor S/C",21);
				else
					TextOut(ps.hdc,231,451,"Water temp sensor O/C",21);
			}
			else
				TextOut(ps.hdc,231,451,"Water temperature",17);

			if (engine.uniram1 & 32)
			{
				// lambda sensor fault
				holdbrush = (HBRUSH)SelectObject(ps.hdc,hbRed);
				RoundRect (ps.hdc,221,456,401,476,20,20);
				SelectObject(ps.hdc,holdbrush);
			}
			TextOut(ps.hdc,231,471,"Lambda sensor",13);

			if (engine.uniram1 & 64)
			{
				// pressure sensor fault
				// if uniram3.8 = 1, short circuit, else open circuit
				holdbrush = (HBRUSH)SelectObject(ps.hdc,hbRed);
				RoundRect (ps.hdc,221,476,401,496,20,20);
				SelectObject(ps.hdc,holdbrush);
				if (engine.uniram3 & 128)
					TextOut(ps.hdc,231,491,"Pressure sensor S/C",19);
				else
					TextOut(ps.hdc,231,491,"Pressure sensor O/C",19);
			}
			else
				TextOut(ps.hdc,231,491,"Pressure sensor",15);
			
			if (engine.uniram1 & 128)
			{
				// throttle position potentiometer
				// if uniram3.4 = 1, short circuit, else open circuit
				holdbrush = (HBRUSH)SelectObject(ps.hdc,hbRed);
				RoundRect (ps.hdc,221,496,401,516,20,20);
				SelectObject(ps.hdc,holdbrush);
				if (engine.uniram3 & 16)
					TextOut(ps.hdc,231,511,"Throttle valve sensor S/C",25);
				else
					TextOut(ps.hdc,231,511,"Throttle valve sensor O/C",25);
			}
			else
				TextOut(ps.hdc,231,511,"Throttle valve sensor",21);

			if (engine.uniram2 & 1)
			{
				// cam sensor problem
				// if uniram3.7 = 1 then short circuit else open circuit
				holdbrush = (HBRUSH)SelectObject(ps.hdc,hbRed);
				RoundRect (ps.hdc,421,436,601,456,20,20);
				SelectObject(ps.hdc,holdbrush);
				if (engine.uniram3 & 64)
					TextOut(ps.hdc,431,451,"Cam sensor S/C",14);
				else
					TextOut(ps.hdc,431,451,"Cam sensor O/C",14);
			}
			else
				TextOut(ps.hdc,431,451,"Cam sensor",10);

			if (engine.uniram2 & 2)
			{
				// I have no idea what the signal panel sequence is...
				// something to do with the instrument panel?
				holdbrush = (HBRUSH)SelectObject(ps.hdc,hbRed);
				RoundRect (ps.hdc,421,456,601,476,20,20);
				SelectObject(ps.hdc,holdbrush);
			}
			TextOut(ps.hdc,431,471,"Signal panel sequence",21);

			if (engine.uniram2 & 0x4)
			{
				// problems with the ECU memory
				// time to start thinking expensive thoughts?
				holdbrush = (HBRUSH)SelectObject(ps.hdc,hbRed);
				RoundRect (ps.hdc,421,476,601,496,20,20);
				SelectObject(ps.hdc,holdbrush);
			}
			TextOut(ps.hdc,431,491,"Eprom, eeprom, or ram",21);

			if (engine.uniram2 & 128)
			{
				// if we knew what a smot sensor was, the world would be a happier place
				// there are strong rumours that it's the main crankshaft sensor
				// it has two flavours of error:
				// uniram3.6 is open or short circuit
				// uniram3.7 if there are six consecutive smot errors
				// the second is the more serious, so we print it last
				holdbrush = (HBRUSH)SelectObject(ps.hdc,hbRed);
				RoundRect (ps.hdc,421,496,601,516,20,20);
				SelectObject(ps.hdc,holdbrush);
				if (engine.uniram3 & 64)
					TextOut(ps.hdc,431,511,"Multiple SMOT errors",20);
				else
				{
					if (engine.uniram3 & 32)
						TextOut(ps.hdc,431,511,"SMOT sensor S/C",15);
					else
						TextOut(ps.hdc,431,511,"SMOT sensor O/C",15);
				}
			}
			else
				TextOut(ps.hdc,431,511,"SMOT sensor",11);


			EndPaint(hWnd,&ps);
			
			break;

		//----------------------------------------------------------------------
		
		case WM_COMMAND:

	char * sub;

			// defined child window messages are in the high word of wParam
			// the low word has the window ident
			if (HIWORD(wParam) == CBN_SELCHANGE)
			{
				switch LOWORD(wParam)
				{
					case IDW_SETCOMMS:				// the com port selection combo drop-down list
						// we need to find the newly selected item
						q = (int)SendMessage(hComlist,CB_GETCURSEL,0,0);
						// now q has an index into the currently unused lpData
						// if q = 0 then we're looking at the 'please select' message
						if (q != 0)
						{
							SendMessage(hComlist,CB_GETLBTEXT,q,(LPARAM)lpData);
							// we're looking for the phrase 'COMxx' somewhere in the string
							// where xx is the port number
							// to be safe let's make everything upper case for now
							for (q=0; q<strlen((const char *)lpData); q++)
							{
								lpData[q] = toupper(lpData[q]);
							}
							// find the string 'COM'
							sub = strstr((char *)lpData, "COM");
							// and if it's a sane sort of thing
							if (strncmp("COM",sub,3) == 0)		// if the first three chars are 'COM' we're probably on the right track
							{
								// actually, we already knew that but what the hell, never hurts to check
								// but we'd actually like (well, it seems *windows* would like) us to have 'Comxx' not 'COMXX'
								// so let's deal with that first...
								//sub[1] = 'o';
								//sub[2] = 'm';
								// and starting at sub[3] should be a number
								for (q=3; q<strlen(sub); q++)
								{
									// go past the number, end the string at first non-numeric
									if (isdigit(sub[q]) == 0)
									{
										// that's the end of the string we need
										sub[q] = '\0';
										break;
									}
								}
								//strcpy(comport,sub);						// so make it the new port
								sprintf(comport,"\\\\.\\%s",sub);
								CloseHandle(rs232);															// close existing port
								SetComms(baudrate);
							}
						}
						break;

					default:
						break;
				}
			}
			
			switch (wParam)
			{
				case ID_FILE_EXIT:
					SendMessage(hWnd,WM_DESTROY,0,0);
					break;

				case ID_ENGINE_16VNA:
					et = _16VNA;
					SetWindowText(hWnd,"Fiat Coupe EMU Monitor V0.3 - 16V NA");
					pressure.Rescale(0,1250,250,50,1500,1200,0,0);
					InvalidateRect(hWnd,NULL,FALSE);
					UpdateWindow(hWnd);
					break;

				case ID_ENGINE_16VTURBO:
					et = _16VT;
					SetWindowText(hWnd,"Fiat Coupe EMU Monitor V0.3 - 16V Turbo");
					pressure.Rescale(0,2500,500,100,1500,1200,0,0);
					InvalidateRect(hWnd,NULL,FALSE);
					UpdateWindow(hWnd);
					break;

				case ID_ENGINE_20VNA:
					et = _20VNA;
					SetWindowText(hWnd,"Fiat Coupe EMU Monitor V0.3 - 20V NA");
					// now we try and make the comms talk
					
					Init20v();

					break;

				case ID_ENGINE_20VTURBO:
					et = _20VT;
					SetWindowText(hWnd,"Fiat Coupe EMU Monitor V0.3 - 20V Turbo");

					initbosch();

					break;

char errortext[1024];
unsigned char ci;
_enginetype oldtype;

				
				case ID_ERRORCODES_RAM:
					// read the error codes from ram, show in a message box
					engine.uniram1 = Get16vEngineStatus(15,255);
					engine.uniram2 = Get16vEngineStatus(16,255);
					engine.uniram3 = Get16vEngineStatus(17,255);
					sprintf(errortext,"Ram 1: %2.2x\nRam 2: %2.2x\nRam 3: %2.2x",engine.uniram1,engine.uniram2,engine.uniram3);
					MessageBox(hWnd, errortext, "Errors currently in RAM (hex)", MB_ICONINFORMATION);
					break;

				case ID_ERRORCODES_EEPROM:
 					engine.unieep1 = Get16vEngineStatus(0x1d,255);
					engine.unieep2 = Get16vEngineStatus(0x1e,255);
					engine.unieep3 = Get16vEngineStatus(0x1f,255);
					sprintf(errortext,"Eeprom 1: %2.2x\nEeprom 2: %2.2x\nEeprom 3: %2.2x",engine.uniram1,engine.uniram2,engine.uniram3);
					MessageBox(hWnd, errortext, "Errors currently in EEPROM (hex)", MB_ICONINFORMATION);
					break;

				case ID_ERRORCODES_ERRORAGE:
					engine.ecthrottle = Get16vEngineStatus(0x20,255);
					engine.ecpressure = Get16vEngineStatus(0x21,255);
					engine.eclambda = Get16vEngineStatus(0x22,255);
					engine.ecwater = Get16vEngineStatus(0x23,255);
					engine.ecknock = Get16vEngineStatus(0x24,255);
					engine.ecair = Get16vEngineStatus(0x25,255);
					engine.ecmix = Get16vEngineStatus(0x26,255);
					engine.ecvae = Get16vEngineStatus(0x27,255);
					engine.ecrpm = Get16vEngineStatus(0x28,255);
					engine.ecram = Get16vEngineStatus(0x29,255);
					engine.ecdigimatic = Get16vEngineStatus(0x2a,255);
					engine.ecnd = Get16vEngineStatus(0x2b,255);
					engine.eceeprom = Get16vEngineStatus(0x2c,255);
					engine.eceprom = Get16vEngineStatus(0x2d,255);
					engine.ecsequence = Get16vEngineStatus(0x2e,255);
					engine.eccam = Get16vEngineStatus(0x2f,255);
					sprintf(errortext,"Throttle:\t\t%2.2x\nPressure:\t\t%2.2x\nLambda:\t\t%2.2x\nWater temp:\t%2.2x\nKnock:\t\t%2.2x\nAir temp:\t\t%2.2x\nMixture:\t\t%2.2x\nVAE (ICV):\t%2.2x\nRPM:\t\t%2.2x\nRAM:\t\t%2.2x\nDigimatic:\t\t%2.2x\nN/D:\t\t%2.2x\nEeprom:\t\t%2.2x\nEprom:\t\t%2.2x\nSequence:\t%2.2x\nCam:\t\t%2.2x",
 									engine.ecthrottle,engine.ecpressure,engine.eclambda,engine.ecwater,
									engine.ecknock,engine.ecair,engine.ecmix,engine.ecvae,engine.ecrpm,
									engine.ecram,engine.ecdigimatic,engine.ecnd,engine.eceeprom,
									engine.eceprom,engine.ecsequence,engine.eccam);
					MessageBox(hWnd,errortext,"Error life counts (Hex)",MB_ICONINFORMATION);
					break;

				case ID_ERRORCODES_IMMOBILISER:
 					engine.univas = Get16vEngineStatus(0x71,255);
					engine.eevas = Get16vEngineStatus(0x72,255);
					engine.crdvas = Get16vEngineStatus(0x73,255);
					sprintf(errortext,"Univas:\t%2.2x\nEevas:\t%2.2x\nCrdvas:\t%2.2x",engine.uniram1,engine.uniram2,engine.uniram3);
					MessageBox(hWnd, errortext, "Immobiliser status bytes", MB_ICONINFORMATION);
					break;

				case ID_ERRORCODES_CLEAR:
					if (MessageBox(hWnd,
										"Ensure engine is stopped before continuing...\nThis command will clear the error data on the engine management unit.\nAre you sure that's what you want to do?",
										"Think twice :)",
										MB_ICONQUESTION | MB_YESNO) == IDYES)
						Get16vEngineStatus(0x86,0);			// send the clearance command
					break;

				case ID_ACTIVETESTING_FUELPUMP:
					if (MessageBox(hWnd,
										"Ensure engine is stopped before continuing...\nThis will test the fuel pump for thirty seconds.\nAre you sure you want to do this?",
										"Think twice :)",
										MB_ICONQUESTION | MB_YESNO) == IDYES)
						Get16vEngineStatus(0x80,0);			// send the clearance command
					break;

				case ID_ACTIVETESTING_INJECTORSINSEQUENCE:
					if (MessageBox(hWnd,
										"Ensure engine is stopped before continuing...\nThis will test each injector five times for five seconds.\nAre you sure you want to do this?",
										"Think twice :)",
										MB_ICONQUESTION | MB_YESNO) == IDYES)
						Get16vEngineStatus(0x81,0);			// send the clearance command
					break;

				case ID_ACTIVETESTING_POWERMODULE1:
					if (MessageBox(hWnd,
										"Ensure engine is stopped before continuing...\nThis will test the spark coil for five seconds.\nAre you sure you want to do this?",
										"Think twice :)",
										MB_ICONQUESTION | MB_YESNO) == IDYES)
						Get16vEngineStatus(0x82,0);			// send the clearance command
					break;

				case ID_ACTIVETESTING_VAE:
					if (MessageBox(hWnd,
										"Ensure engine is stopped before continuing...\nThis will test the VAE (aka the ICR) for five seconds.\nAre you sure you want to do this?",
										"Think twice :)",
										MB_ICONQUESTION | MB_YESNO) == IDYES)
						Get16vEngineStatus(0x83,0);			// send the clearance command
					break;

				case ID_ACTIVETESTING_OVERBOOST:
					if (MessageBox(hWnd,
										"Ensure engine is stopped before continuing...\nThis will test the overboost valve for 5 seconds.\nAssuming you have a turbo, of course.\nAre you sure you want to do this?",
										"Think twice :)",
										MB_ICONQUESTION | MB_YESNO) == IDYES)
						Get16vEngineStatus(0x84,0);			// send the clearance command
					break;

				case ID_ACTIVETESTING_POWERMODULE2:
					if (MessageBox(hWnd,
										"Ensure engine is stopped before continuing...\nThis will test powermodule two, whatever that is, for five seconds.\nAre you sure you want to do this?",
										"Think twice :)",
										MB_ICONQUESTION | MB_YESNO) == IDYES)
						Get16vEngineStatus(0x85,0);			// send the clearance command
					break;

				case ID_ACTIVETESTING_REVCOUNTER:
					if (MessageBox(hWnd,
										"Ensure engine is stopped before continuing...\nThis will test the rev counter. It should show 3750rpm for two seconds.\nAre you sure you want to do this?",
										"Think twice :)",
										MB_ICONQUESTION | MB_YESNO) == IDYES)
					{
						// stop the timer updates; we don't want these while we're exercising
						// rather than stop it, just say we have no engine selected
						oldtype = et;
						et = NOTHING;
						// ensure engine is stopped first
						if ((Get16vEngineStatus(1,1) == 0) && (Get16vEngineStatus(2,1) == 0))
						{
							// start active test mode
							// send 0xaa and wait for an echoing 0xaa
							if (Get16vEngineStatus(0xaa,0) == 0xaa)
							{
								// ok, we're in active mode
								if (Get16vEngineStatus(0x89,0) == 0x89)			// send the test command
								{ 
									// we successfully started the command
									// now we wait until the ecu returns a pass or fail
									ci = 0;
									// this could use a timeout...
									while (ci == 0)
										ReadFile(rs232,&ci,1,&rxcount,NULL);
									if (ci == 0xff)
										// success has crowned our very efforts...
										MessageBox(hWnd,"Test completed successfully","Rev Counter test",MB_OK);
									else
										MessageBox(hWnd,"ECU reports test failure","Rev Counter test",MB_OK);
								}
								else
								{
									MessageBox(hWnd,"ECU did not respond to test request","Rev Counter test",MB_OK);
								}
							}
							else
							{
								MessageBox(hWnd,"ECU won't go into test mode","Rev Counter test",MB_OK);
							}
						}
						else
						{
							MessageBox(hWnd,"Engine must be stopped to do this test","Stop engine!",MB_OK);
						}
						// restart the updates
						et = oldtype;
					}

					break;

				case ID_ACTIVETESTING_INJECTOR1:
					if (MessageBox(hWnd,
										"Ensure engine is stopped before continuing...\nThis will test injector 1 five times in five seconds.\nAre you sure you want to do this?",
										"Think twice :)",
										MB_ICONQUESTION | MB_YESNO) == IDYES)
						Get16vEngineStatus(0x8c,0);			// send the clearance command
					break;

				case ID_ACTIVETESTING_INJECTOR2:
					if (MessageBox(hWnd,
										"Ensure engine is stopped before continuing...\nThis will test injector 2 five times in five seconds.\nAre you sure you want to do this?",
										"Think twice :)",
										MB_ICONQUESTION | MB_YESNO) == IDYES)
						Get16vEngineStatus(0x8d,0);			// send the clearance command
					break;

				case ID_ACTIVETESTING_INJECTOR3:
					if (MessageBox(hWnd,
										"Ensure engine is stopped before continuing...\nThis will test injector 3 five times in five seconds.\nAre you sure you want to do this?",
										"Think twice :)",
										MB_ICONQUESTION | MB_YESNO) == IDYES)
						Get16vEngineStatus(0x8e,0);			// send the clearance command
					break;

				case ID_ACTIVETESTING_INJECTOR4:
					if (MessageBox(hWnd,
										"Ensure engine is stopped before continuing...\nThis will test injector 4 five times in five seconds.\nAre you sure you want to do this?",
										"Think twice :)",
										MB_ICONQUESTION | MB_YESNO) == IDYES)
						Get16vEngineStatus(0x8f,0);			// send the clearance command
					break;


HMENU	hmenubar,hdropdown;

				case ID_LOGGING_ON:
					if (!Logging)
					{
						hmenubar = GetMenu(hWnd);
						hdropdown = GetSubMenu(hmenubar,2);
			
						// open a file
						// we'll use a single file and overwrite it every time we run
						// otherwise we'd end up with dozens of files
						// if you want to keep it, change the name after the program has closed

						if ((fo = fopen("engine details.csv","wt")) == 0)
						{
							// couldn't open the file
							MessageBox(hWnd,"Unable to open the log file...\nno data will be logged","File Error",MB_ICONINFORMATION);
							CheckMenuItem(hdropdown,ID_LOGGING_ON,MF_UNCHECKED | MF_BYCOMMAND);
							CheckMenuItem(hdropdown,ID_LOGGING_OFF,MF_CHECKED | MF_BYCOMMAND);
							Logging = FALSE;
						}
						else																																																						
						{
							fprintf(fo,"revs, water temp, air temp, throttle, injector period, injector timing, advance, volts, pressure, VAE, error 1, error 2, error 3, , revs, water temp, air temp, throttle, injector period, injector timing, advance, volts, pressure, VAE\n");
							CheckMenuItem(hdropdown,ID_LOGGING_ON,MF_CHECKED | MF_BYCOMMAND);
							CheckMenuItem(hdropdown,ID_LOGGING_OFF,MF_UNCHECKED | MF_BYCOMMAND);
							Logging = TRUE;
						}
					}
					break;

				case ID_LOGGING_OFF:
					if (Logging)
					{
						hmenubar = GetMenu(hWnd);
						hdropdown = GetSubMenu(hmenubar,2);
						CheckMenuItem(hdropdown,ID_LOGGING_ON,MF_UNCHECKED | MF_BYCOMMAND);
						CheckMenuItem(hdropdown,ID_LOGGING_OFF,MF_CHECKED | MF_BYCOMMAND);
						Logging = FALSE;
						_fcloseall();
					}
					break;

				default:
					break;
			}
			break;

	    default:            // default windows message processing 
  		return DefWindowProc (hWnd, iMessage, wParam, lParam) ;
  }
  return (0L) ;
}

//---------------------------------------------------------------------------
//
// Serial helper functions
//
//---------------------------------------------------------------------------



void SetComms (int baud)
{

	// set the comms specs
	// we use the comms defined in the global 'comport'

	rs232 = CreateFile (comport,											// we want the serial port
											GENERIC_READ|GENERIC_WRITE,		// for reading and writing
											0,														// only by us
											NULL,													// no child security attributes
				              OPEN_EXISTING,								// because it's the com port
											FILE_ATTRIBUTE_NORMAL,				// we don't want overlapped stuff for single bytes
											NULL);												// no template info allowed

	// check the damn thing opened properly
	if (rs232 == INVALID_HANDLE_VALUE)
	{
	LPVOID lpMsgBuf;
 
		FormatMessage( 
				FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
				NULL,
				GetLastError(),
				MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
				(LPTSTR) &lpMsgBuf,
				0,
				NULL);

		// Display the string.
		MessageBox( NULL, (const char *)lpMsgBuf, "GetLastError", MB_OK|MB_ICONINFORMATION );

		// Free the buffer.
		LocalFree( lpMsgBuf );
		
		// and politely crash
		MessageBox( NULL, "There's an issue with the serial port; I can't find it!\nI'm going to have to shut down now.",
								"Serial port error", MB_OK|MB_ICONSTOP);
		SendMessage(hWnd,WM_DESTROY,0,0);
		
	}

	// now, see what it looks like
	GetCommState(rs232,&dcb);

	// that has filled the control block with sensible numbers, but we need to change some
	// specifically, it has set the correct size for the size element

	//dcb.BaudRate							= 7680;									// as near as we can get to the required 7812.5
	dcb.BaudRate							= baud;	
	dcb.fBinary								= 1;
	dcb.fParity								= 0;										// no parity
  dcb.fOutxCtsFlow					= 0;
  dcb.fOutxDsrFlow					= 0;
  dcb.fDtrControl						= DTR_CONTROL_DISABLE; 
  dcb.fDsrSensitivity				= 0;
  dcb.fTXContinueOnXoff			= 1; 
  dcb.fOutX									= 0;
  dcb.fInX									= 0;
  dcb.fErrorChar						= 0; 
  dcb.fNull									= 0;
  dcb.fRtsControl						= RTS_CONTROL_DISABLE; 
  dcb.fAbortOnError					= 0; 
  dcb.ByteSize							= 8;
  dcb.Parity								= 0;
  dcb.StopBits							= 0;										// one stop bit

	SetCommState(rs232,&dcb);

	// let's see what the time-out functions are...
	GetCommTimeouts(rs232,&cto);
	cto.ReadTotalTimeoutConstant = 500;								// read timeout of 50mS
	SetCommTimeouts(rs232,&cto);

	// and one last thing - set DTR and clear RTS
//	EscapeCommFunction(rs232,SETDTR);
//	EscapeCommFunction(rs232,CLRRTS);

	// we do this so we can power an rs232-ttl converter from the serial port
	// after this, data is output on pin 3, received on pin 2, pin 4 has +v
	// (6.2 on my toshiba portege), and pin 7 has -v (-5.8 on the tosh).
	// ground reference is on pin 5

}


unsigned char	Get16vEngineStatus (unsigned char ch, unsigned char noshow)
{

	// send a character to the engine, wait for the response, and return that response
	// if the loop times out, we return 'noshow'

unsigned char ci;
HBRUSH holdbrush;
HDC hDC;

	//return ch; //<<<<<<<<<<test

	// clear the return in case of timeout
	ci = 0;

	PurgeComm(rs232,PURGE_RXABORT	| PURGE_RXCLEAR);
	// write a little red spot to the screen
	hDC = GetDC(hWnd);
	holdbrush = (HBRUSH)SelectObject(hDC,hbRed);
	RoundRect (hDC,1,1,15,15,15,15);

	// send to port
	WriteFile(rs232,&ch,1,&txcount,NULL);
	SleepEx(10,FALSE);

	// read it back
	rxcount = 0;
	ReadFile(rs232,&ci,1,&rxcount,NULL);
	if (rxcount == 0)
		ci = noshow;

	SelectObject(hDC,GetStockObject(BLACK_BRUSH));
	RoundRect(hDC,1,1,15,15,15,15);
	SelectObject(hDC,holdbrush);
	ReleaseDC(hWnd,hDC);

	return (ci);

}

/*
for twenty valve engines, we have two problems...

firstly, the data is arranged totally differently from the	16v
secondly, a single line is used to send and receive the data

For the 20v system, we start with a signon - 10h at *5* baud
To my great surprise, the serial chip will actually work that low!

The engine should then, within 400mS respond with a six byte preamble. The engine
must be operating at less than 2000rpm or be ignition on, but not started, or the
signon will not be accepted

The emu responds with the preamble, and the tester must respond with the complement of
the third byte of the preamble. If no response is received within 1.2 seconds, the preamble
is sent up to two more times.

The spec does not clarify but it appears from the timing that the ID signal cannot be
at 5 baud; I assume it is at 4800 baud as the remainder of the comms are.

After the ecu is happy that the tester is present, it sends an ID block. This is thirty bytes
long, so it is sent in a number of smaller chunks (the spec doesn't say how many but I
suspect three) cnsisting of ten bytes of bosch hardware ID, ten bytes of bosch software ID,
and ten bytes of fiat drawing number.

All comms are sent in frames. A frame consists of:

	one byte		frame length		length of frame (max 15 bytes) following this byte inc etx
	one byte		frame counter		an increasing frame count maintained by the tester
	one byte		frame title			what the frame is requesting or supplying
	1-12 bytes	data						maximum of twelve bytes
	1 byte			etx							end of frame = 0x03

There must be a gap of no more than 40mS between successive bytes in a frame, and one
frame must be received by the ecu at least once per second to maintain the comms open.
Each byte is echoed in complement by the ecu. 

There are several frames possible; the values are different whether the ecu or the 
tester initiates the request

	type																tester	ecu
	id block														???			???
	read error memory										0x07		0xfc
	delete error memory									0x05		0x09 (ack)
	read ram values											0x01		0xfe
	read A/D channels										0x08		0xfb
	actuator commands										0x04		0x09 (ack)
	end of diagnosis										0x06		no response
	acknowledge (ack)										0x09		variable response
	no acknowledge (retry)							0x0a		variable response
	tx security code										0x24		0xea

After a frame has been transmitted, the receiver must respond with an ack, or a nack
if the frame was not understood, in which case the frame is transmitted again.

From startup, then, we have:

	tester																ecu

	(initialise)
	0x10 byte at 5 baud										
	(get preamble)
																				0x55 0x32 0x86 0xxx 0xxx 0xxx
	(acknowledge preamble)
	complement of byte three received
	(verify preamble)
																				Either repeat of preamble block if unhappy, in which 
																				case tester sends complement of byte three again,
																				or
	(hardware/software id)
																				ID frame
	ack frame
																				ID frame
	ack frame							
																				ID frame
	ack frame								
																				until 30 bytes have been sent, then

																				ack frame
	(normal comms begin)
	request frame 1		
																				response frame 1
	ack frame														
																				ack frame
	request frame 2	
																				response frame 2
	request frame 3									
																				response frame 3
	(comms ends with timeout or end of diagnosis frame, no response)

	After each byte is sent by the tester, the ecu must respond with the inverse of
	the byte, except for the eot byte which is returned non-inverted

	eek!

	*/

// somewhere to keep raw data from the engine
static unsigned char raw[25];			// <-- lots of space for variables
// and a structure to store  20v errors

struct error20v 
{
	unsigned char errornum;
	unsigned char errortype;
	unsigned char errorenv1;
	unsigned char errorenv2;
	unsigned char errorage;
};

// we need space for five errors maximum
static struct error20v errors[5];

// and a flag: true if there are errors to display
static char	show20verror;

// and the sixteen valve codes we need to use to access them are

#define q16_revsh	0x01
#define q16_revsl	0x02
#define q16_injph	0x03
#define q16_injpl	0x04
#define q16_adv		0x05
#define q16_press	0x06
#define q16_air		0x07
#define q16_water	0x08
#define q16_throttle	0x09
#define q16_volts	0x0a
#define q16_inja	0x0c
#define q16_vae		0x0d
#define q16_uni1	0x0f
#define q16_uni2	0x10
#define q16_uni3	0x11

// we will add a few extra for the useful 20v differences
#define q20_volh	0x12
#define q20_voll	0x13
#define q20_lambda 0x14
#define q20_lambdaint 0x15
#define q20_speed	0x16

// engine parameters
unsigned int e_revs;				// rpm
unsigned int e_injection;			// tens of microseconds
unsigned int e_advance;			// degrees
unsigned int e_pressure;			// millibar
int e_airtemp;			// degrees c
int e_watertemp;			// degrees c
unsigned int e_throttle;			// degrees
unsigned int e_battery;			// millivolts
unsigned int e_injectora;			// degrees
unsigned int e_icr;				// percent
unsigned char e_uniram1;			// binary 8 bit
unsigned char e_uniram2;			// binary 8 bit
unsigned char e_uniram3;			// binary 8 bit
unsigned int e_lambda;				// millivolts
unsigned int e_lambdaint;			// percent -108/+108%
unsigned int e_speed;				// vehicle speed in km/h



int Init20v (void)
{
	// open communications with the bosch ecu
	// return true if comms have been successfully negotiated

char ch;

	//
	dcb.BaudRate = 4800;	
	SetupComm(rs232,64,64);
	SetCommState(rs232,&dcb);
	EscapeCommFunction(rs232,SETDTR);

		
	ch = 0x33;												// the address of the ecu

char test[20];

	sprintf(test,"%d returned",WriteFile(rs232,&ch,1,&txcount,NULL));
	SetWindowText(hWnd,test);

	SleepEx(2000,FALSE);
	//sprintf(test,"1234567890qwertyu");
	//WriteFile(rs232,test,1,&txcount,NULL);

	// now we're waiting for six bytes identifying the vehicle 
	// we have to reset the baud rate to 4800

	dcb.BaudRate = 4800;	
	SetupComm(rs232,64,64);
	SetCommState(rs232,&dcb);
	EscapeCommFunction(rs232,SETDTR);
	ReadFile(rs232,rxbuffer,6,&rxcount,NULL);


	return TRUE;
}


// this defines the frame used to tx and rx data
static char isoframe[16];
	
#define isolength 0
#define isocount 1
#define isotitle 2
#define isoinfo 3

#define isoaddress	0x01	
//	request reading of ram address
#define isoactuator	0x04
//	request actuator test
#define isoerrordel	0x05
//	request deletion of error memory
#define isoend	0x06
//	request end of diagnosis
#define isoerrorread 0x07
//	request error memory read
#define isoadread 0x08
//	request reading of AD channels
#define isoack	0x09
//	acknowledge
#define isonack	0x0a
//	no acknowledge
#define isosecurity	0x24
//	transmission of security code
#define isosecreply	0xea
//	response: security code
#define isoadreply 0xfb
//	response: AD channels
#define isoerrorreply 0xfc
//	response: error memory
#define isoramreply	0xfe
//	response: ram data


// and the static frame counter
static char isoframecount;


#define ETX 0x03

void read20all(void)
{
int error = 0;
char tmp[128];

	// we ask for a reading of ram cells
	// if we get the first 10 bytes, we'll have:
	// engine revs high and low
	// engine water temperature
	// intake air temperature
	// throttle angle
	// air flow 	(either high and low or two different values')
	// advance angle
	// injection time high and low
	//
	// we ask by building a packet
	// length 6
	// title isoaddress
	// address 0x2000
	// number of bytes 10
	//
	// first we build the isoframe
	isoframe[isoinfo] = 10;				// ten frames please
	isoframe[isoinfo+1] = 0x20;			// address 0x2000
	isoframe[isoinfo+2] = 0x00;			// address 0x2000
	error = frametx(isoaddress,3);		// payload three bytes; ask for data
	if (error)
		MessageBox(hWnd,"Error in ram address frame tx","20v comms error",MB_ICONINFORMATION);
		
	error = framerx();					// wait for the reply
	if (error)							// lost comms? reset...
		while (initbosch() == 1);
	
	// assume it got back in one piece
	// debug: show the error return and data
	sprintf(tmp,"\n\rfrx = %d\n\r",error);
	//ser2_print(tmp);
	//for (int q=0; q<16; q++)
	//	{
	//	sprintf(tmp," %.2x",isoframe[q]);
	//	ser2_print(tmp);
	//	}
	//ser2_print("\n\r");

	// and transfer the data from the isoframe to raw[]
	// zero the ones we're not using yet - air flow needs thinking about
	raw[q16_revsh] =isoframe[isoinfo+0];
	raw[q16_revsl] = isoframe[isoinfo+1];
	raw[q16_injph] = isoframe[isoinfo+8];
	raw[q16_injpl] = isoframe[isoinfo+9];
	raw[q16_adv] = isoframe[isoinfo+7];
	raw[q16_press] = 0;
	raw[q16_air] = isoframe[isoinfo+3];
	raw[q16_water] = isoframe[isoinfo+2];
	raw[q16_throttle] = isoframe[isoinfo+4];

	raw[q20_volh] = isoframe[isoinfo+5];
	raw[q20_voll] = isoframe[isoinfo+6];

	// we still need the battery voltage (2010), speed (2011),
	// the lambda voltage (2014), and the integrated lambda output (2016)

	// we build another isoframe
	isoframe[isoinfo] = 7;				// seven frames please
	isoframe[isoinfo+1] = 0x20;			// address 0x2000
	isoframe[isoinfo+2] = 0x10;			// address 0x2100
	error = frametx(isoaddress,3);		// payload three bytes; ask for data
	if (error)
		MessageBox(hWnd,"Error in ram address frame tx","20v comms error",MB_ICONINFORMATION);
		
	error = framerx();					// wait for the reply
	if (error)							// lost comms? reset...
		while (initbosch() == 1);
	
	// assume it got back in one piece
	// debug: show the error return and data
	sprintf(tmp,"\n\rfrx = %d\n\r",error);			//<-- needed to make a small delay, probably...
	//ser2_print(tmp);

	// and transfer this data to raw[]
	
	raw[q16_volts] = isoframe[isoinfo];
	raw[q20_speed] = isoframe[isoinfo+1];
	raw[q20_lambda] = isoframe[isoinfo+4];
	raw[q20_lambdaint] = isoframe[isoinfo+6];
	
	// now we need to consider the errors
	// it can take several accesses to get the data, which might
	// be 25 bytes long - so we do this only once a minute
	// we ask for an error value.
	// then we loop and send acks until we get either only a single errorcode
	// (five bytes) or an ack (last error already received)



int errorcount;

	if ((time(NULL)%20) == 0)
	{
		errorcount = 0;
		// once a minute
		// debug
		//ser2_print("Checking errors\n\r");

		// clear the requirement to show an error
		show20verror = 0;

		// we build an isoframe
		error = frametx(isoerrorread,0);		// payload zero bytes; ask for error memory read
		if (error)
			MessageBox(hWnd,"Error in error memory frame tx","20v comms error",MB_ICONINFORMATION);
			
		error = framerx();					// wait for the reply
		if (error)									// lost comms? reset...
			while (initbosch() == 1);
		
		// assume it got back in one piece
		// debug: show the error return and data
		sprintf(tmp,"\n\rfrx = %d\n\r",error);			//<-- needed to make a small delay, probably...

		while (isoframe[isotitle] != isoack)
		{
			// ok, it wasn't an ack, so there's some error messages we need to grab
			if (isoframe[isolength] < 8)
				// then it isn't what we expected, probably an ack
				break;

			if (isoframe[isolength] == 8)
			{
				// one error packet
				// copy the packet to the next available slot in the error table
				errors[errorcount].errornum = isoframe[isoinfo];
				errors[errorcount].errortype = isoframe[isoinfo+1];
				errors[errorcount].errorenv1 = isoframe[isoinfo+2];
				errors[errorcount].errorenv2 = isoframe[isoinfo+3];
				errors[errorcount].errorage = isoframe[isoinfo+4];
				errorcount++;
				// and flag that we have an error
				show20verror = errorcount;
				// and quit; we're finished
			}
			else
			{
				// must be two packets to grab
				errors[errorcount].errornum = isoframe[isoinfo];
				errors[errorcount].errortype = isoframe[isoinfo+1];
				errors[errorcount].errorenv1 = isoframe[isoinfo+2];
				errors[errorcount].errorenv2 = isoframe[isoinfo+3];
				errors[errorcount].errorage = isoframe[isoinfo+4];
				errorcount++;
				errors[errorcount].errornum = isoframe[isoinfo+5];
				errors[errorcount].errortype = isoframe[isoinfo+6];
				errors[errorcount].errorenv1 = isoframe[isoinfo+7];
				errors[errorcount].errorenv2 = isoframe[isoinfo+8];
				errors[errorcount].errorage = isoframe[isoinfo+9];
				errorcount++;
				// flag the errors
				show20verror = errorcount;
			}

			// having dealt with the errors, are there any more?
			error = frametx(isoack,0);
			if (error)
				MessageBox(hWnd,"Error in error memory frame internal ack","20v comms error",MB_ICONINFORMATION);
				
			error = framerx();					// wait for the reply
			if (error)									// lost comms? reset...
				while (initbosch() == 1);
			
			// assume it got back in one piece
			// debug: show the error return and data
			sprintf(tmp,"\n\rfrx = %d\n\r",error);			//<-- needed to make a small delay, probably...

			// and then we will loop again if we haven't had an ack back
		}
	
		//sprintf (tmp, "%d errors\n\r",errorcount);
		//ser2_print(tmp);
		
		//for (int q=0; q<errorcount; q++)
		//{
			// dump the errors we've collected for testing
		//	sprintf(tmp,"%0.2x %d\n\r",errors[q].errornum,errors[q].errorage);
		//	ser2_print(tmp);
		//}
		
		// once we're here, we've had all the error messages coming (or non)
		// handling them can take place in the display routine
	}
}

void translate20()
{
//int tmp;
	
	// now we must translate what we got into something useful...

	// revs - there are two revsvalues which appear to be the same at different resolution levels
	// revsl * ten up to 2500 rpm; revsh * forty above
	// it seems that one selects the appropriate cell but it's not clear whether the result is cleared or maxed
	// let's test the first and then if it's not above 2500, display the other.
	if ((raw[q16_revsh]*40)>2500)
		e_revs = (int)(raw[q16_revsh])*40;
	else
		e_revs = (int)(raw[q16_revsl])*10;
	
	// the air and water temperature sensors have a response curve designed to give the programmer a headache.
	// A lookup table is the easy way :)
	
	e_airtemp = temperature[raw[q16_air]];
	
	// same trick for water
	
	e_watertemp = temperature[raw[q16_water]];
	
	// throttle position
	// multiply by 96/230.4 to get degrees
	e_throttle = (int)((((float)raw[q16_throttle])*96)/230.4);
	
	// for the airflow, there's another dual value like the revs
	// above 25.1 cubic metres per hour, we use the high value
	// otherwise the low value... 
	// for now we'll put it in the pressure value
	if ((raw[q20_volh]*1.6)>51)
		e_pressure = (int)(raw[q20_volh]*1.6);
	else
		e_pressure = (int)(raw[q20_voll]*0.2);
		
	// advance angle
	// 78 - datum * 0.75 - presumable normal precedence rules apply?
	e_advance = 78 - (int)((float)raw[q16_adv] * (float)0.75);
	
	// injector time
	// again, a dual value
	// it's not explicit, but the high byte is specified as datum*0.384
	// and the low byte as datum/255 which implies that values above 1ms should be from the high byte
	if ((raw[q16_injph]*0.384)>1)
		e_injection = (int)(raw[q16_injph]*384);		// to give an answer in microseconds
	else
		e_injection =(int)((raw[q16_injpl]*1000)/255);

	// battery voltage
	// multiply data by 0.0705, but we want millivolts, so use 70.5
	e_battery = (int)((float)raw[q16_volts]*70.5);

	// speed is data * 1 in km/h
	e_speed = (int)raw[q20_speed];

	// lambda sensor voltage
	// this will be all over the place as the closed-loop system oscilates
	// multiply by 1.25 and divide by 255 for volts; we would like millivolts
	// so multiply by 1250 and divide by 255
	e_lambda = (int)(((float)raw[q20_lambda]*1250)/255);

	// lambda voltage integrated
	// result is a percentage ranging from -102% to +102%
	// multiply datum by 0.8 to get percentage, but note that
	// 0x00 = -102%, 0x80 = 0, 0xff = +102%
	// we would like a single scaled value to display, so we could
	// just multiply by 0.8% and ignore the centre offset; we'll sort 
	// that out in the display routine
	e_lambdaint = (int)((float)raw[q20_lambdaint]*0.8);
	
	e_uniram1 = 0;
	e_uniram2 = 0;
	e_uniram3 = 0;


}


// frames and the handling thereof...
// once communication has been established, a master/slave process negotiates
// the actual data transfer.
// To do this a series of frames are used. The initiator of the transfer is the 
// master, the receiver is the slave.
//
// the frame consists of the above structure isoframe, along with a ETX byte
//	length = the following number of bytes in the frame - max 15
//	count  = an incrementing frame counter
//	title  = the type of operation requested or carried out
//				0x01	request reading of ram address
//				0x04	request actuator test
//				0x05	request deletion of error memory
//				0x06	request end of diagnosis
//				0x07	request error memory read
//				0x08	request reading of AD channels
//				0x09	acknowledge
//				0x0a	no acknowledge
//				0x24	transmission of security code
//				0xea	response: security code
//				0xfb	response: AD channels
//				0xfc	response: error memory
//				0xfe	response: ram data
//	info[12]= up to twelve bytes of data or commands
// and then finally the ETX byte 0x03
//
// When the slave receives each byte of the master frame, it shall respond by replying
// with the complement of the byte just received within 40mS, except for the ETX byte which is 
// replied by another ETX byte.
//
// Finally the data requested by the master is returned, with the roles of master and
// slave changing place.
//
// To keep the channel alive, at least an exchange of acknowledge packets must be
// negotiated every second.
//
// Because a single line is used to handle data in both directions, and it is impractical
// to enable and disable the receiver between individual bytes and still guarantee correct
// reception, when a byte is transmitted, it is also received.
//
// Thus, a send_byte routine needs to send the byte requested, receive and discard its own
// echo, receive the complemented response byte, and return a true or false depending 
// on the result.
//
// A frame transmit routine needs to maintain a frame count; create and send the bosch isoframe,
// and return true or false depending on any errors in the return data.
//
// A receive_byte routine needs to store the data and return the complement of the received byte, 
// or ETX as required. (It's rumoured that the ETX is not echoed in either direction - but of course the
// ETX can occur other than at the end of a frame)
//
// A frame receive routine needs to fill an isoframe with incoming data, complementing and
// returning bytes as appropriate; it must also return a true/false

int boschtx (unsigned char ch, int respond)
{
	// transmit a single byte to the line
	// if respond == 1, we expect to receive the complement of the transmitted byte
	// if respond == 0, we expect no response
	// if respond == 2, we expect the transmitted byte returned unchanged
	// wait until an appropriate byte has been returned by the slave
	// or a timeout
	// correct response returns 0;
	// timeout returns 1;
	// incorrect response returns 2;
	
int found;
unsigned char rx;
char tmp[30];
char chtemp;

	chtemp = ch;
	WriteFile(rs232,&chtemp,1,&txcount,NULL);

	// receive the byte we just sent
	rxcount = 0;
	ReadFile(rs232,&chtemp,1,&rxcount,NULL);

	// now we wait for the ecu to reply - if we haven't sent an ETX
	found = 0;						// assume we will be ok
	
	switch(respond)
	{
		case 0:
			//ser2_print("no reponse expected\n\r");
			found = 0;
			break;
		
		case 1:
			// expecting complemented return
			found = 1;					// assume we will timeout
			rxcount = 0;
			ReadFile(rs232,&chtemp,1,&rxcount,NULL);
			// we need to compare it with the outgoing byte
			if (ch != ~rx)			// if the return wasn't the complement
				//found = 2;			// oops, bad return
				found = 0;
			else
				found = 0;			// good return
			break;
				
		case 2:
			// expecting non-complemented return
			found = 1;					// assume we will timeout
			rxcount = 0;
			ReadFile(rs232,&chtemp,1,&rxcount,NULL);
			// we need to compare it with the outgoing byte
			if (ch != rx)			// if the return wasn't the complement
				found = 2;			// oops, bad return
				//found = 0;
			else
				found = 0;			// good return
			break;

		default:
			break;
	}

	// returns 0 for ok, 1 for timeout, 2 for error return
	sprintf(tmp,"%d",found);
	//ser2_print(tmp);
	return found;
}

	
int boschrx (char * pch, int respond)
{
	// we are listening for a character as part of a frame receive
	// if we receive anything, we have to respond with the complement of
	// the received data
	// in the case of the final ETX, we either respond with the complement or with nothing
	// the docs are not clear
	// if 'respond' = 1, we reply with the complement (we can't just test for ETX as it can occur
	// within the packet).
	// if 'respond' = 0, we do not reply with anything
	// if 'respond' = 2, we reply with the received character
	// after we have transmitted the response we wait for the echo to be received
	// and discard it
	// if we receive no data within two seconds, then the ecu has broken contact
	// so we return 1; if we respond we return 0 (to match tx return)
	
int found = 0;
char tmp[30];
char chtemp;

	rxcount = 0;
	ReadFile(rs232,pch,1,&rxcount,NULL);
	//*pch = ser1_in();
	
	// debug - the data from the ecu
	sprintf(tmp,"%.2x ",*pch);		// <-- if I take this line out it fails!
	//ser2_print(tmp);

	// send the response if requested
	// may need a short delay here
	switch (respond)		
	{
		case 0:		// we return nothing...
			//ser2_print("...\n\r");
			break;
			
		case 1:		// we return the complement
			//sprintf(tmp,"%.2x ",(unsigned char)(~(*pch)));
			//ser2_print(tmp);
			//ser1_out(~(*pch));
			chtemp = ~(*pch);
			WriteFile(rs232,&chtemp,1,&txcount,NULL);
			// receive the byte we just sent
			rxcount = 0;
			ReadFile(rs232,&chtemp,1,&rxcount,NULL);

			// now we wait for the echo
			rxcount = 0;
			ReadFile(rs232,&chtemp,1,&rxcount,NULL);
			//sprintf(tmp," %.2x\n\r",(unsigned char)ser1_in());
			break;
			
		case 2:		// we return the data as received
			//sprintf(tmp," %.2x \n\r",(unsigned char)(*pch));
			//ser2_print(tmp);
			//ser1_out(~(*pch));						// <--- I wonder why I left this inverted?
			chtemp = ~(*pch);
			WriteFile(rs232,&chtemp,1,&txcount,NULL);
			// receive the byte we just sent
			rxcount = 0;
			ReadFile(rs232,&chtemp,1,&rxcount,NULL);

			// now we wait for the echo
			rxcount = 0;
			ReadFile(rs232,&chtemp,1,&rxcount,NULL);
			//sprintf(tmp," %.2x\n\r",ser1_in());
			break;
			
		default:
			break;
	}
	// now found=0 if timeout, or 1 if received
	// we want it the other way up
	// return =1 if timeout, 0 if received data
	return (1-found);
	//return 0;
}

int frametx (unsigned char title, unsigned char length)
{	
	// transmit a single frame to the far end
	// before calling, the frame will have had its info field 
	// filled in by the calling routine
	
int error = 0;
char tmp[10];

	//ser2_print("ftx ");
	// we start by completing the isoframe structure
	isoframe[isolength] = length+3;
	isoframe[isocount] = isoframecount;
	isoframe[isotitle] = title;
	
	for (int q=0; q<(length+3); q++)
	{
		// send each byte, watch for errors
		sprintf(tmp,"%.2x ",isoframe[q]);
		//ser2_print(tmp);
		error = boschtx(isoframe[q],1);		// we need to get a complement response from ecu
		if (error != 0) 
		{
			
			//ser2_print("Error\n\r");
			break;
		}
	}
	
	// if we get here without error, we need to send the etx
	//if (error == 0)
		error = boschtx(ETX,0);				// expect non-complement response
		
	// and if we had any errors we need to deal with them, but we let the 
	// calling routine handle it - options are 1 = timeout, 2 = bad response 
	
	return error;
}

int framerx (void)
{
	// receive an isoframe from the ecu
	// we don't know how many bytes until they start coming... we let
	// boschrx look after the echo bytes
	// but we have to watch for the end byte
	
int error = 0;
//char tmp [40];
int q=0;
	
	// clear the frame buffer
	for (q=0; q<16; q++)
	{
		isoframe[q] = 0;
	}
		
	// first byte is always the length
	// returns 1 for timeout error, otherwise zero
	error = boschrx(&isoframe[isolength],1);
	
	// if we haven't had a timeout error, get the rest of the data
	if (~error)
	{
		// everything except the etx byte
		for (q=0; q<isoframe[isolength]-1; q++)
		{
			error = boschrx(&isoframe[q+isocount], 1);
			if (error)
				break;
		}
		// and then we listen for the etx byte, if no error yet
		if (~error)
		{
			error = boschrx(&isoframe[q+isocount],0);			// <-- return with no complement
			// now keep the framecount so it can be used by tx
			isoframecount = isoframe[isocount]+1;
			//sprintf(tmp,"frame = %d\n\r",isoframecount);
			//ser2_print(tmp);
		}
	}
	
	// now return with the error value if anything
	// error = 1: timeout

	return error;
}


// the code to initialise comms with the ecu

int initbosch (void)
{
int q;
unsigned char id[6];
char tmp[128];	// debug
char ch;
unsigned long rxcount;
unsigned char idcount = 0;
int error = 0;



	MessageBox(hWnd,"Initialising comms to ECU","20v/vt",MB_ICONINFORMATION);
	
	dcb.BaudRate = 5;	
	SetupComm(rs232,64,64);
	SetCommState(rs232,&dcb);

	// the time period for ten bits at 5 baud is 2 seconds, so we need to change the timeout
	// while we send the start data
	GetCommTimeouts(rs232,&cto);
	cto.ReadTotalTimeoutConstant = 2000;								// read timeout of 2 seconds
	SetCommTimeouts(rs232,&cto);
	
	// send the 5 baud start code 0x10
	ch = 0x10;
	WriteFile(rs232,&ch,1,&txcount,NULL);
	SleepEx(2000,FALSE);

	// we should have received a single byte 0x10 and we can throw it away...
	// as it's the one we just sent
	rxcount = 0;
	ReadFile(rs232,&ch,1,&rxcount,NULL);

	// debug
	sprintf(tmp,"got %d chars",rxcount);
	MessageBox(hWnd,tmp,"5 baud rx",MB_ICONINFORMATION);


	// now we can reset the baud rate to 4800
	dcb.BaudRate = 4800;	
	SetupComm(rs232,64,64);
	SetCommState(rs232,&dcb);



	// we then expect the ecu to respond with six ID bytes
	// ***THIS NEEDS A TIMEOUT AND ERROR***
	rxcount = 0;
	ReadFile(rs232,&id,6,&rxcount,NULL);

	sprintf(tmp, "Engine ID code: %.2x %.2x %.2x %.2x %.2x %.2x", id[0],id[1],id[2],id[3],id[4],id[5]);
	MessageBox (hWnd,tmp,"ID response",MB_ICONINFORMATION);
		
	
	if (rxcount != 6)
		return 1;						// error, we didn't get six returns in five secs
	// we should have six id codes in the id buffer now
	// we need to wait between 5 and 1200mS and then send the complement of id[2]

	ch = (unsigned char)~(id[2]);
	WriteFile(rs232,&ch,1,&txcount,NULL);
	
	// wait for the echo
	ReadFile(rs232,&ch,1,&rxcount,NULL);

	// now we start with frames
	// so clear the frame count first thing
	
	isoframecount = 0;
	
	// and if all this works, the ecu sends an unknown number of ID frames
	// detailing hardware, software, and engine ID data - 30 bytes, so
	// probably at least three frames
	
	// we don't know how many frames the ID will be hidden in, but it's 30 bytes
	// and we don't really want them at this stage, so we'll just throw them away
	// tsk tsk, how wasteful
	
	while (idcount < 30)
	{
		// the ecu speaks first
		// so we need to listen
		error = framerx();
		
		// debug: show the error return and data
		//sprintf(tmp,"\n\rfrx = %d\n\r",error);
		//ser2_print(tmp);
		for (q=0; q<16; q++)
		{
			sprintf(tmp," %.2x",isoframe[q]);
			//ser2_print(tmp);
		}
		//ser2_print("\n\r");
		
		// we assume it's valid, for now
		idcount+=isoframe[isolength]-3;
		
		sprintf(tmp,"\n\ridcount = %d\n\r",idcount);
		//ser2_print(tmp);
		
		// we send an ack frame
		error = frametx(isoack,0);
		//error = quickack();
		sprintf(tmp,"\n\rack return error = %d\n\r",error);
	}
	
	// and then let the calling routine deal with the error, if there is one
	// if we got an error, we didn't get sync :(
	// so we need to do the whole damn thing again
	
	// however, if there wasn't an error, we need to wait for a single ack packet
	// before we start talking
	
	error = framerx();					// for now, no testing, just assume that's what it is.
		
	
	return error;
}		




// for reference, the working code from the barnacle widget
/*

// Now for the fun part
// the 20v/vt :eek:
//
// the comms sequence is completely different from the 16v and requires more processor
// intervention to keep it working...
//
// first, initialise comms
// a single byte of 0x10 is sent at five baud
// the ecu will repsond unless:
//	engine doing over 2000 rpm
//	start bit incorrect
//	stop bit incorrect
//	parity bit incorrect
// unfortunately fiat don't specify whether the data is 5, 7, or 8 bits,
// or whether odd or even parity... we assume 7+p
//
// so, one of the following bit patterns should work:
//	11 0 0000100 0 1
//	11 0 0000100 1 1
//  11 0 00001000 0 1
//  11 0 00001000 1 1
// which break down to a couple of periods high/idle, start bit, seven or eight data,
// parity in both senses, and a stop bit
//
// and it turns out to be -> 11 0 0000100 0 1 which we get by calling boschinit(7,0)
//
// to make life complicated, everything happens on the K line; whereas on the 16v 
// commands go *to* the L line from the diagnostic and are listened *from* the K line.
// This means that the two lines must be connected together on the tester and a resistor
// removed.

// this defines the frame used to tx and rx data
unsigned char isoframe[16];
	
#define isolength 0
#define isocount 1
#define isotitle 2
#define isoinfo 3

#define isoaddress	0x01	
//	request reading of ram address
#define isoactuator	0x04
//	request actuator test
#define isoerrordel	0x05
//	request deletion of error memory
#define isoend	0x06
//	request end of diagnosis
#define isoerrorread 0x07
//	request error memory read
#define isoadread 0x08
//	request reading of AD channels
#define isoack	0x09
//	acknowledge
#define isonack	0x0a
//	no acknowledge
#define isosecurity	0x24
//	transmission of security code
#define isosecreply	0xea
//	response: security code
#define isoadreply 0xfb
//	response: AD channels
#define isoerrorreply 0xfc
//	response: error memory
#define isoramreply	0xfe
//	response: ram data


// and the static frame counter
static unsigned char isoframecount;


#define ETX 0x03

void read20all(void)
{
int error = 0;

	// we ask for a reading of ram cells
	// if we get the first 10 bytes, we'll have:
	// engine revs high and low
	// engine water temperature
	// intake air temperature
	// throttle angle
	// air flow 	(either high and low or two different values')
	// advance angle
	// injection time high and low
	//
	// we ask by building a packet
	// length 6
	// title isoaddress
	// address 0x2000
	// number of bytes 10
	//
	// first we build the isoframe
	isoframe[isoinfo] = 10;				// ten frames please
	isoframe[isoinfo+1] = 0x20;			// address 0x2000
	isoframe[isoinfo+2] = 0x00;			// address 0x2000
	error = frametx(isoaddress,3);		// payload three bytes; ask for data
	if (error)
		ser2_print("Error in ram address frame tx\n\r");
		
	error = framerx();					// wait for the reply
	if (error)							// lost comms? reset...
		while (initbosch(7,0) == 1);
	
	// assume it got back in one piece
	// debug: show the error return and data
	sprintf(tmp,"\n\rfrx = %d\n\r",error);
	//ser2_print(tmp);
	//for (int q=0; q<16; q++)
	//	{
	//	sprintf(tmp," %.2x",isoframe[q]);
	//	ser2_print(tmp);
	//	}
	//ser2_print("\n\r");

	// and transfer the data from the isoframe to raw[]
	// zero the ones we're not using yet - air flow needs thinking about
	raw[q16_revsh] =isoframe[isoinfo+0];
	raw[q16_revsl] = isoframe[isoinfo+1];
	raw[q16_injph] = isoframe[isoinfo+8];
	raw[q16_injpl] = isoframe[isoinfo+9];
	raw[q16_adv] = isoframe[isoinfo+7];
	raw[q16_press] = 0;
	raw[q16_air] = isoframe[isoinfo+3];
	raw[q16_water] = isoframe[isoinfo+2];
	raw[q16_throttle] = isoframe[isoinfo+4];

	raw[q20_volh] = isoframe[isoinfo+5];
	raw[q20_voll] = isoframe[isoinfo+6];

	// we still need the battery voltage (2010), speed (2011),
	// the lambda voltage (2014), and the integrated lambda output (2016)

	// we build another isoframe
	isoframe[isoinfo] = 7;				// seven frames please
	isoframe[isoinfo+1] = 0x20;			// address 0x2000
	isoframe[isoinfo+2] = 0x10;			// address 0x2100
	error = frametx(isoaddress,3);		// payload three bytes; ask for data
	if (error)
		ser2_print("Error in ram address frame tx\n\r");
		
	error = framerx();					// wait for the reply
	if (error)							// lost comms? reset...
		while (initbosch(7,0) == 1);
	
	// assume it got back in one piece
	// debug: show the error return and data
	sprintf(tmp,"\n\rfrx = %d\n\r",error);			//<-- needed to make a small delay, probably...
	//ser2_print(tmp);

	// and transfer this data to raw[]
	
	raw[q16_volts] = isoframe[isoinfo];
	raw[q20_speed] = isoframe[isoinfo+1];
	raw[q20_lambda] = isoframe[isoinfo+4];
	raw[q20_lambdaint] = isoframe[isoinfo+6];
	
	// now we need to consider the errors
	// it can take several accesses to get the data, which might
	// be 25 bytes long - so we do this only once a minute
	// we ask for an error value.
	// then we loop and send acks until we get either only a single errorcode
	// (five bytes) or an ack (last error already received)



int errorcount;

	if ((seconds%20) == 0)
	{
		errorcount = 0;
		// once a minute
		// debug
		//ser2_print("Checking errors\n\r");

		// clear the requirement to show an error
		show20verror = 0;

		// we build an isoframe
		error = frametx(isoerrorread,0);		// payload zero bytes; ask for error memory read
		if (error)
			ser2_print("Error in error memory frame tx\n\r");
			
		error = framerx();					// wait for the reply
		if (error)									// lost comms? reset...
			while (initbosch(7,0) == 1);
		
		// assume it got back in one piece
		// debug: show the error return and data
		sprintf(tmp,"\n\rfrx = %d\n\r",error);			//<-- needed to make a small delay, probably...

		while (isoframe[isotitle] != isoack)
		{
			// ok, it wasn't an ack, so there's some error messages we need to grab
			if (isoframe[isolength] < 8)
				// then it isn't what we expected, probably an ack
				break;

			if (isoframe[isolength] == 8)
			{
				// one error packet
				// copy the packet to the next available slot in the error table
				errors[errorcount].errornum = isoframe[isoinfo];
				errors[errorcount].errortype = isoframe[isoinfo+1];
				errors[errorcount].errorenv1 = isoframe[isoinfo+2];
				errors[errorcount].errorenv2 = isoframe[isoinfo+3];
				errors[errorcount].errorage = isoframe[isoinfo+4];
				errorcount++;
				// and flag that we have an error
				show20verror = errorcount;
				// and quit; we're finished
			}
			else
			{
				// must be two packets to grab
				errors[errorcount].errornum = isoframe[isoinfo];
				errors[errorcount].errortype = isoframe[isoinfo+1];
				errors[errorcount].errorenv1 = isoframe[isoinfo+2];
				errors[errorcount].errorenv2 = isoframe[isoinfo+3];
				errors[errorcount].errorage = isoframe[isoinfo+4];
				errorcount++;
				errors[errorcount].errornum = isoframe[isoinfo+5];
				errors[errorcount].errortype = isoframe[isoinfo+6];
				errors[errorcount].errorenv1 = isoframe[isoinfo+7];
				errors[errorcount].errorenv2 = isoframe[isoinfo+8];
				errors[errorcount].errorage = isoframe[isoinfo+9];
				errorcount++;
				// flag the errors
				show20verror = errorcount;
			}

			// having dealt with the errors, are there any more?
			error = frametx(isoack,0);
			if (error)
				ser2_print("Error in error memory frame internal ack\n\r");
				
			error = framerx();					// wait for the reply
			if (error)									// lost comms? reset...
				while (initbosch(7,0) == 1);
			
			// assume it got back in one piece
			// debug: show the error return and data
			sprintf(tmp,"\n\rfrx = %d\n\r",error);			//<-- needed to make a small delay, probably...

			// and then we will loop again if we haven't had an ack back
		}
	
		//sprintf (tmp, "%d errors\n\r",errorcount);
		//ser2_print(tmp);
		
		//for (int q=0; q<errorcount; q++)
		//{
			// dump the errors we've collected for testing
		//	sprintf(tmp,"%0.2x %d\n\r",errors[q].errornum,errors[q].errorage);
		//	ser2_print(tmp);
		//}
		
		// once we're here, we've had all the error messages coming (or non)
		// handling them can take place in the display routine
	}
}

void translate20()
{
//int tmp;
	
	// now we must translate what we got into something useful...

	// revs - there are two revsvalues which appear to be the same at different resolution levels
	// revsl * ten up to 2500 rpm; revsh * forty above
	// it seems that one selects the appropriate cell but it's not clear whether the result is cleared or maxed
	// let's test the first and then if it's not above 2500, display the other.
	if ((raw[q16_revsh]*40)>2500)
		e_revs = (int)(raw[q16_revsh])*40;
	else
		e_revs = (int)(raw[q16_revsl])*10;
	
	// the air and water temperature sensors have a response curve designed to give the programmer a headache.
	// A lookup table is the easy way :)
	
	e_airtemp = (int)pgm_read_byte(raw[q16_air]+temperature20);
	
	// same trick for water
	
	e_watertemp = (int)pgm_read_byte(raw[q16_water]+temperature20);
	
	// throttle position
	// multiply by 96/230.4 to get degrees
	e_throttle = (int)((((float)raw[q16_throttle])*96)/230.4);
	
	// for the airflow, there's another dual value like the revs
	// above 25.1 cubic metres per hour, we use the high value
	// otherwise the low value... 
	// for now we'll put it in the pressure value
	if ((raw[q20_volh]*1.6)>51)
		e_pressure = (int)(raw[q20_volh]*1.6);
	else
		e_pressure = (int)(raw[q20_voll]*0.2);
		
	// advance angle
	// 78 - datum * 0.75 - presumable normal precedence rules apply?
	e_advance = 78 - (int)((float)raw[q16_adv] * (float)0.75);
	
	// injector time
	// again, a dual value
	// it's not explicit, but the high byte is specified as datum*0.384
	// and the low byte as datum/255 which implies that values above 1ms should be from the high byte
	if ((raw[q16_injph]*0.384)>1)
		e_injection = (int)(raw[q16_injph]*384);		// to give an answer in microseconds
	else
		e_injection =(int)((raw[q16_injpl]*1000)/255);

	// battery voltage
	// multiply data by 0.0705, but we want millivolts, so use 70.5
	e_battery = (int)((float)raw[q16_volts]*70.5);

	// speed is data * 1 in km/h
	e_speed = (int)raw[q20_speed];

	// lambda sensor voltage
	// this will be all over the place as the closed-loop system oscilates
	// multiply by 1.25 and divide by 255 for volts; we would like millivolts
	// so multiply by 1250 and divide by 255
	e_lambda = (int)(((float)raw[q20_lambda]*1250)/255);

	// lambda voltage integrated
	// result is a percentage ranging from -102% to +102%
	// multiply datum by 0.8 to get percentage, but note that
	// 0x00 = -102%, 0x80 = 0, 0xff = +102%
	// we would like a single scaled value to display, so we could
	// just multiply by 0.8% and ignore the centre offset; we'll sort 
	// that out in the display routine
	e_lambdaint = (int)((float)raw[q20_lambdaint]*0.8);
	
	e_uniram1 = 0;
	e_uniram2 = 0;
	e_uniram3 = 0;


}

void fivebaudbit (int bit)
{
	// sends a single bit to the data out line
	// assumes that the serial port is disabled or that will override the port commands,
	// and that the port bit PD1 has been set to output
	//
	// 5 baud needs a 200mS bit period; we have a convenient 20mS tick available
	//
	// using this compensates automatically for any delay in the bit selection
	// routine, provided it's called within 20mS of the previous call
	
int timer;
int ticks = 0;

	timer = 10;						// twenty five fiftieths
	ticks = fiftieths;				// get the actual count
	
	if (bit)
	{
		// set the output high
		PORTD |= 2;
		//ser2_print("1");
	}
	else
	{
		// clear the output
		PORTD &= 0xFD;
		//ser2_print("0");
	}
		
	
	while (timer != 0)				// and spin in the loop until the timer exp
	{
		// see if the fiftieths have changed
		if (ticks != fiftieths)
		{
			// they have, so decrement the timer
			timer--;
			// and update the reference
			ticks = fiftieths;
		}
	}
	return;
}

int initbosch (int length, int parity)
{
int q;
unsigned char id[6];
char tmp[40];	// debug

int timer;
int tick;


	// clear screen for debug
	lcd_cls();
	
	lcd_print("Initialising comms");
	lcd_set_cursor(0,1);
	
	// turn the usart off
	UCSRB = 0;
	
	// set TX pin to output
	DDRD |= 2;
	
	// bitbang the  low-baud initialisation
	// send a couple of bits of high/idle, to give the far end time to wake up
	fivebaudbit(1);
	fivebaudbit(1);
	
	// the start bit
	fivebaudbit(0);
	
	// the data, low four bits first
	for (q=0; q<4; q++)
		fivebaudbit(0);
		
	// the high bit 4
	fivebaudbit(1);
	
	// then either two or three remaining zeros
	for (q=5; q<length; q++)
		fivebaudbit(0);
		
	// the parity bit - we don't calculate it, we get told...
	fivebaudbit(parity);
	
	// and finally the stop bit
	fivebaudbit(1);
		
	// now and only now we can start the serial port again
	ser1_init(103);			// 4800 baud
	

	// we expect the ecu to respond with six ID bytes
	// ***THIS NEEDS A TIMEOUT AND ERROR***
	
	lcd_print("id: ");
	q = 0;
	timer = 250;						// five seconds in fiftieths
	tick = fiftieths;						// get the actual count
	
	while (timer != 0)				// and spin in the loop until the timer expires
	{
		// see if the fiftieths have changed
		if (tick != fiftieths)
		{
			timer--;
			// and update the reference
			tick = fiftieths;
		}
	
		if (ser1_ischar())
		{
			id[q] = ser1_in();
			sprintf(tmp,"%.2x",id[q++]);		// debug - convert response to hex
			lcd_print(tmp);				// debug - and display it
			if (q == 6)
				break;
		}
	}
	
	//ser2_print("\n\rwaiting for engine ID response... ");
	
	//lcd_print("id: ");
	//for (q=0; q<6; q++)
	//{
	//	while (ser1_ischar() == 0);		// wait for the characters
	//	{
	//		id[q] = ser1_in();
	//		sprintf(tmp,"%.2x",id[q]);		// debug - convert response to hex
	//		lcd_print(tmp);				// debug - and display it
	//	}
	//}
	//ser2_print("\n\r");
	
	if (q != 6)
		return 1;						// error, we didn't get six returns in five secs
	// we should have six id codes in the id buffer now
	// we need to wait between 5 and 1200mS and then send the complement of id[2]
	// easy way to delay 200mS is call the fivebaudbit - since the uart has control
	// it makes no difference to the output

	ser1_out((unsigned char)~(id[2]));		//<--- the doc says 'key 2'
												// depends where they start counting
	// and don't forget we need to nuke the echo
	while (ser1_ischar()==0);					// wait for the echo
	ser1_in();								// discard it


	// now we start with frames
	// so clear the frame count first thing
	
	isoframecount = 0;
	
	// and if all this works, the ecu sends an unknown number of ID frames
	// detailing hardware, software, and engine ID data - 30 bytes, so
	// probably at least three frames
	
unsigned char idcount = 0;
int error = 0;

	// we don't know how many frames the ID will be hidden in, but it's 30 bytes
	// and we don't really want them at this stage, so we'll just throw them away
	// tsk tsk, how wasteful
	
	while (idcount < 30)
	{
		// the ecu speaks first
		// so we need to listen
		error = framerx();
		
		// debug: show the error return and data
		//sprintf(tmp,"\n\rfrx = %d\n\r",error);
		//ser2_print(tmp);
		for (q=0; q<16; q++)
		{
			sprintf(tmp," %.2x",isoframe[q]);
			//ser2_print(tmp);
		}
		//ser2_print("\n\r");
		
		// we assume it's valid, for now
		idcount+=isoframe[isolength]-3;
		
		sprintf(tmp,"\n\ridcount = %d\n\r",idcount);
		//ser2_print(tmp);
		
		// we send an ack frame
		error = frametx(isoack,0);
		//error = quickack();
		sprintf(tmp,"\n\rack return error = %d\n\r",error);
	}
	
	// and then let the calling routine deal with the error, if there is one
	// if we got an error, we didn't get sync :(
	// so we need to do the whole damn thing again
	
	// however, if there wasn't an error, we need to wait for a single ack packet
	// before we start talking
	
	error = framerx();					// for now, no testing, just assume that's what it is.
		
	
	return error;
}		

// frames and the handling thereof...
// once communication has been established, a master/slave process negotiates
// the actual data transfer.
// To do this a series of frames are used. The initiator of the transfer is the 
// master, the receiver is the slave.
//
// the frame consists of the above structure isoframe, along with a ETX byte
//	length = the following number of bytes in the frame - max 15
//	count  = an incrementing frame counter
//	title  = the type of operation requested or carried out
//				0x01	request reading of ram address
//				0x04	request actuator test
//				0x05	request deletion of error memory
//				0x06	request end of diagnosis
//				0x07	request error memory read
//				0x08	request reading of AD channels
//				0x09	acknowledge
//				0x0a	no acknowledge
//				0x24	transmission of security code
//				0xea	response: security code
//				0xfb	response: AD channels
//				0xfc	response: error memory
//				0xfe	response: ram data
//	info[12]= up to twelve bytes of data or commands
// and then finally the ETX byte 0x03
//
// When the slave receives each byte of the master frame, it shall respond by replying
// with the complement of the byte just received within 40mS, except for the ETX byte which is 
// replied by another ETX byte.
//
// Finally the data requested by the master is returned, with the roles of master and
// slave changing place.
//
// To keep the channel alive, at least an exchange of acknowledge packets must be
// negotiated every second.
//
// Because a single line is used to handle data in both directions, and it is impractical
// to enable and disable the receiver between individual bytes and still guarantee correct
// reception, when a byte is transmitted, it is also received.
//
// Thus, a send_byte routine needs to send the byte requested, receive and discard its own
// echo, receive the complemented response byte, and return a true or false depending 
// on the result.
//
// A frame transmit routine needs to maintain a frame count; create and send the bosch isoframe,
// and return true or false depending on any errors in the return data.
//
// A receive_byte routine needs to store the data and return the complement of the received byte, 
// or ETX as required. (It's rumoured that the ETX is not echoed in either direction - but of course the
// ETX can occur other than at the end of a frame)
//
// A frame receive routine needs to fill an isoframe with incoming data, complementing and
// returning bytes as appropriate; it must also return a true/false

int boschtx (unsigned char ch, int respond)
{
	// transmit a single byte to the line
	// if respond == 1, we expect to receive the complement of the transmitted byte
	// if respond == 0, we expect no response
	// if respond == 2, we expect the transmitted byte returned unchanged
	// wait until an appropriate byte has been returned by the slave
	// or a timeout
	// correct response returns 0;
	// timeout returns 1;
	// incorrect response returns 2;
	
int timer;
int found;
unsigned char rx;
int tick;
char tmp[30];

	//sprintf(tmp,">%.2x",ch);
	//ser2_print(tmp);
	timer = 100;						// response should be less than 40ms; we give 2 seconds
	tick = fiftieths;				// get the actual count
	
	ser1_out(ch);					// send the command 
	
	while (ser1_ischar() == 0);			// wait for echo
	ser1_in();
	//sprintf(tmp," %.2x",ser1_in());						// and discard it
	//ser2_print(tmp);
	
	// now we wait for the ecu to reply - if we haven't sent an ETX
	found = 0;						// assume we wil be ok
	
	switch(respond)
	{
		case 0:
			//ser2_print("no reponse expected\n\r");
			found = 0;
			break;
		
		case 1:
			// expecting complemented return
			//sprintf(tmp," %.2x",(unsigned char)~ch);
			//ser2_print("(1)");
			
			found = 1;					// assume we will timeout
			while (timer != 0)				// and spin in the loop until the timer expires
			{
				// see if the fiftieths have changed
				if (tick != fiftieths)
				{
					// they have, so decrement the timer
					timer--;
					// and update the reference
					tick = fiftieths;
				}
				
				if (ser1_ischar())				// this is the return value from the ecu
				{
					rx = ser1_in();		
				
					// debug
					//sprintf(tmp, "-%.2x",rx);
					//ser2_print(tmp);
				
					// we need to compare it with the outgoing byte
					if (ch != ~rx)			// if the return wasn't the complement
						//found = 2;			// oops, bad return
						found = 0;
					else
						found = 0;			// good return
					break;
				}
			}	
			break;
			
		case 2:
			// expecting non-complemented return
			//sprintf(tmp,"Expecting %.2x\n\r",ch);
			//ser2_print("(2)");
			
			found = 1;					// assume we will timeout
			while (timer != 0)				// and spin in the loop until the timer expires
			{
				// see if the fiftieths have changed
				if (tick != fiftieths)
				{
					// they have, so decrement the timer
					timer--;
					// and update the reference
					tick = fiftieths;
				}
				
				if (ser1_ischar())				// this is the return value from the ecu
				{
					rx = ser1_in();		
				
					// debug
					//sprintf(tmp, "%.2x",rx);
					//ser2_print(tmp);
				
					// we need to compare it with the outgoing byte
					if (ch != rx)			// if the return wasn't what we sent...
						found = 2;			// oops, bad return
					else
						found = 0;			// good return
					break;
				}
			}	
			break;
			
		default:
			break;
	}

	// returns 0 for ok, 1 for timeout, 2 for error return
	sprintf(tmp,"%d",found);
	//ser2_print(tmp);
	return found;
}

	
int boschrx (char * pch, int respond)
{
	// we are listening for a character as part of a frame receive
	// if we receive anything, we have to respond with the complement of
	// the received data
	// in the case of the final ETX, we either respond with the complement or with nothing
	// the docs are not clear
	// if 'respond' = 1, we reply with the complement (we can't just test for ETX as it can occur
	// within the packet).
	// if 'respond' = 0, we do not reply with anything
	// if 'respond' = 2, we reply with the received character
	// after we have transmitted the response we wait for the echo to be received
	// and discard it
	// if we receive no data within two seconds, then the ecu has broken contact
	// so we return 1; if we respond we return 0 (to match tx return)
	
int found = 0;
int tick = 0;
static int timer;
char tmp[30];

	timer = 100;						// two seconds in fiftieths
	tick = fiftieths;						// get the actual count
	
	while (timer != 0)				// and spin in the loop until the timer expires
	{
		// see if the fiftieths have changed
		if (tick != fiftieths)
		{
			timer--;
			// and update the reference
			tick = fiftieths;
		}
	
		if (ser1_ischar())
		{
			found = 1;
			break;
		}
	}
	if (found)
	{
		// data awaits us, so read it
		*pch = ser1_in();
		
		// debug - the data from the ecu
		sprintf(tmp,"%.2x ",*pch);		// <-- if I take this line out it fails!
		//ser2_print(tmp);

		// send the response if requested
		// may need a short delay here
		switch (respond)		
		{
			case 0:		// we return nothing...
				//ser2_print("...\n\r");
				break;
				
			case 1:		// we return the complement
				//sprintf(tmp,"%.2x ",(unsigned char)(~(*pch)));
				//ser2_print(tmp);
				
				ser1_out(~(*pch));
				// now we wait for the echo
				while (!(ser1_ischar()));
				ser1_in();
				//sprintf(tmp," %.2x\n\r",(unsigned char)ser1_in());
				break;
				
			case 2:		// we return the data as received
				//sprintf(tmp," %.2x \n\r",(unsigned char)(*pch));
				//ser2_print(tmp);
				ser1_out(~(*pch));
				// now we wait for the echo
				while (!(ser1_ischar()));
				ser1_in();
				//sprintf(tmp," %.2x\n\r",ser1_in());
				break;
				
			default:
				break;
		}
	}
	
	// now found=0 if timeout, or 1 if received
	// we want it the other way up
	// return =1 if timeout, 0 if received data
	return (1-found);
	//return 0;
}

int frametx (unsigned char title, unsigned char length)
{	
	// transmit a single frame to the far end
	// before calling, the frame will have had its info field 
	// filled in by the calling routine
	
int error = 0;
char tmp[10];

	//ser2_print("ftx ");
	// we start by completing the isoframe structure
	isoframe[isolength] = length+3;
	isoframe[isocount] = isoframecount;
	isoframe[isotitle] = title;
	
	for (int q=0; q<(length+3); q++)
	{
		// send each byte, watch for errors
		sprintf(tmp,"%.2x ",isoframe[q]);
		//ser2_print(tmp);
		error = boschtx(isoframe[q],1);		// we need to get a complement response from ecu
		if (error != 0) 
		{
			
			//ser2_print("Error\n\r");
			break;
		}
	}
	
	// if we get here without error, we need to send the etx
	//if (error == 0)
		error = boschtx(ETX,0);				// expect non-complement response
		
	// and if we had any errors we need to deal with them, but we let the 
	// calling routine handle it - options are 1 = timeout, 2 = bad response 
	
	return error;
}

int framerx (void)
{
	// receive an isoframe from the ecu
	// we don't know how many bytes until they start coming... we let
	// boschrx look after the echo bytes
	// but we have to watch for the end byte
	
int error = 0;
//char tmp [40];
int q=0;
	
	// clear the frame buffer
	for (q=0; q<16; q++)
	{
		isoframe[q] = 0;
	}
		
	// first byte is always the length
	// returns 1 for timeout error, otherwise zero
	error = boschrx(&isoframe[isolength],1);
	
	// if we haven't had a timeout error, get the rest of the data
	if (~error)
	{
		// everything except the etx byte
		for (q=0; q<isoframe[isolength]-1; q++)
		{
			error = boschrx(&isoframe[q+isocount], 1);
			if (error)
				break;
		}
		// and then we listen for the etx byte, if no error yet
		if (~error)
		{
			error = boschrx(&isoframe[q+isocount],0);			// <-- return with no complement
			// now keep the framecount so it can be used by tx
			isoframecount = isoframe[isocount]+1;
			//sprintf(tmp,"frame = %d\n\r",isoframecount);
			//ser2_print(tmp);
		}
	}
	
	// now return with the error value if anything
	// error = 1: timeout

	return error;
}
*/